package cast

import (
	"github.com/z7zmey/php-parser/node"
	"github.com/z7zmey/php-parser/walker"
)

// CastUnset node
type CastUnset struct {
	Cast
}

// NewCastUnset node constuctor
func NewCastUnset(Expr node.Node) *CastUnset {
	return &CastUnset{
		Cast{
			Expr,
		},
	}
}

// Attributes returns node attributes as map
func (n *CastUnset) Attributes() map[string]interface{} {
	return nil
}

// Walk traverses nodes
// Walk is invoked recursively until v.EnterNode returns true
func (n *CastUnset) Walk(v walker.Visitor) {
	if v.EnterNode(n) == false {
		return
	}

	if n.Expr != nil {
		vv := v.GetChildrenVisitor("Expr")
		n.Expr.Walk(vv)
	}

	v.LeaveNode(n)
}
