//line php5/php5.y:2
package php5

import __yyfmt__ "fmt"

//line php5/php5.y:2
import (
	//    "fmt"
	//    "strings"
	//    "strconv"

	"github.com/z7zmey/php-parser/node"
	"github.com/z7zmey/php-parser/node/expr"
	"github.com/z7zmey/php-parser/node/name"
	"github.com/z7zmey/php-parser/node/scalar"
	"github.com/z7zmey/php-parser/node/stmt"
	"github.com/z7zmey/php-parser/token"

//    "github.com/z7zmey/php-parser/node/expr/assign_op"
//    "github.com/z7zmey/php-parser/node/expr/binary_op"
//    "github.com/z7zmey/php-parser/node/expr/cast"
)

//line php5/php5.y:22
type yySymType struct {
	yys   int
	node  node.Node
	token token.Token
	//    boolWithToken boolWithToken
	list []node.Node
	//    foreachVariable foreachVariable
	//    nodesWithEndToken *nodesWithEndToken
	simpleIndirectReference simpleIndirectReference
	//    str string
}

const T_INCLUDE = 57346
const T_INCLUDE_ONCE = 57347
const T_EXIT = 57348
const T_IF = 57349
const T_LNUMBER = 57350
const T_DNUMBER = 57351
const T_STRING = 57352
const T_STRING_VARNAME = 57353
const T_VARIABLE = 57354
const T_NUM_STRING = 57355
const T_INLINE_HTML = 57356
const T_CHARACTER = 57357
const T_BAD_CHARACTER = 57358
const T_ENCAPSED_AND_WHITESPACE = 57359
const T_CONSTANT_ENCAPSED_STRING = 57360
const T_ECHO = 57361
const T_DO = 57362
const T_WHILE = 57363
const T_ENDWHILE = 57364
const T_FOR = 57365
const T_ENDFOR = 57366
const T_FOREACH = 57367
const T_ENDFOREACH = 57368
const T_DECLARE = 57369
const T_ENDDECLARE = 57370
const T_AS = 57371
const T_SWITCH = 57372
const T_ENDSWITCH = 57373
const T_CASE = 57374
const T_DEFAULT = 57375
const T_BREAK = 57376
const T_CONTINUE = 57377
const T_GOTO = 57378
const T_FUNCTION = 57379
const T_CONST = 57380
const T_RETURN = 57381
const T_TRY = 57382
const T_CATCH = 57383
const T_FINALLY = 57384
const T_THROW = 57385
const T_USE = 57386
const T_INSTEADOF = 57387
const T_GLOBAL = 57388
const T_VAR = 57389
const T_UNSET = 57390
const T_ISSET = 57391
const T_EMPTY = 57392
const T_HALT_COMPILER = 57393
const T_CLASS = 57394
const T_TRAIT = 57395
const T_INTERFACE = 57396
const T_EXTENDS = 57397
const T_IMPLEMENTS = 57398
const T_OBJECT_OPERATOR = 57399
const T_DOUBLE_ARROW = 57400
const T_LIST = 57401
const T_ARRAY = 57402
const T_CALLABLE = 57403
const T_CLASS_C = 57404
const T_TRAIT_C = 57405
const T_METHOD_C = 57406
const T_FUNC_C = 57407
const T_LINE = 57408
const T_FILE = 57409
const T_COMMENT = 57410
const T_DOC_COMMENT = 57411
const T_OPEN_TAG = 57412
const T_OPEN_TAG_WITH_ECHO = 57413
const T_CLOSE_TAG = 57414
const T_WHITESPACE = 57415
const T_START_HEREDOC = 57416
const T_END_HEREDOC = 57417
const T_DOLLAR_OPEN_CURLY_BRACES = 57418
const T_CURLY_OPEN = 57419
const T_PAAMAYIM_NEKUDOTAYIM = 57420
const T_NAMESPACE = 57421
const T_NS_C = 57422
const T_DIR = 57423
const T_NS_SEPARATOR = 57424
const T_ELLIPSIS = 57425
const T_EVAL = 57426
const T_REQUIRE = 57427
const T_REQUIRE_ONCE = 57428
const T_LOGICAL_OR = 57429
const T_LOGICAL_XOR = 57430
const T_LOGICAL_AND = 57431
const T_INSTANCEOF = 57432
const T_NEW = 57433
const T_CLONE = 57434
const T_ELSEIF = 57435
const T_ELSE = 57436
const T_ENDIF = 57437
const T_PRINT = 57438
const T_YIELD = 57439
const T_STATIC = 57440
const T_ABSTRACT = 57441
const T_FINAL = 57442
const T_PRIVATE = 57443
const T_PROTECTED = 57444
const T_PUBLIC = 57445
const T_INC = 57446
const T_DEC = 57447
const T_YIELD_FROM = 57448
const T_INT_CAST = 57449
const T_DOUBLE_CAST = 57450
const T_STRING_CAST = 57451
const T_ARRAY_CAST = 57452
const T_OBJECT_CAST = 57453
const T_BOOL_CAST = 57454
const T_UNSET_CAST = 57455
const T_COALESCE = 57456
const T_SPACESHIP = 57457
const T_NOELSE = 57458
const T_PLUS_EQUAL = 57459
const T_MINUS_EQUAL = 57460
const T_MUL_EQUAL = 57461
const T_DIV_EQUAL = 57462
const T_CONCAT_EQUAL = 57463
const T_MOD_EQUAL = 57464
const T_AND_EQUAL = 57465
const T_OR_EQUAL = 57466
const T_XOR_EQUAL = 57467
const T_SL_EQUAL = 57468
const T_SR_EQUAL = 57469
const T_POW_EQUAL = 57470
const T_BOOLEAN_OR = 57471
const T_BOOLEAN_AND = 57472
const T_IS_EQUAL = 57473
const T_IS_NOT_EQUAL = 57474
const T_IS_IDENTICAL = 57475
const T_IS_NOT_IDENTICAL = 57476
const T_IS_SMALLER_OR_EQUAL = 57477
const T_IS_GREATER_OR_EQUAL = 57478
const T_SL = 57479
const T_SR = 57480
const T_POW = 57481

var yyToknames = [...]string{
	"$end",
	"error",
	"$unk",
	"T_INCLUDE",
	"T_INCLUDE_ONCE",
	"T_EXIT",
	"T_IF",
	"T_LNUMBER",
	"T_DNUMBER",
	"T_STRING",
	"T_STRING_VARNAME",
	"T_VARIABLE",
	"T_NUM_STRING",
	"T_INLINE_HTML",
	"T_CHARACTER",
	"T_BAD_CHARACTER",
	"T_ENCAPSED_AND_WHITESPACE",
	"T_CONSTANT_ENCAPSED_STRING",
	"T_ECHO",
	"T_DO",
	"T_WHILE",
	"T_ENDWHILE",
	"T_FOR",
	"T_ENDFOR",
	"T_FOREACH",
	"T_ENDFOREACH",
	"T_DECLARE",
	"T_ENDDECLARE",
	"T_AS",
	"T_SWITCH",
	"T_ENDSWITCH",
	"T_CASE",
	"T_DEFAULT",
	"T_BREAK",
	"T_CONTINUE",
	"T_GOTO",
	"T_FUNCTION",
	"T_CONST",
	"T_RETURN",
	"T_TRY",
	"T_CATCH",
	"T_FINALLY",
	"T_THROW",
	"T_USE",
	"T_INSTEADOF",
	"T_GLOBAL",
	"T_VAR",
	"T_UNSET",
	"T_ISSET",
	"T_EMPTY",
	"T_HALT_COMPILER",
	"T_CLASS",
	"T_TRAIT",
	"T_INTERFACE",
	"T_EXTENDS",
	"T_IMPLEMENTS",
	"T_OBJECT_OPERATOR",
	"T_DOUBLE_ARROW",
	"T_LIST",
	"T_ARRAY",
	"T_CALLABLE",
	"T_CLASS_C",
	"T_TRAIT_C",
	"T_METHOD_C",
	"T_FUNC_C",
	"T_LINE",
	"T_FILE",
	"T_COMMENT",
	"T_DOC_COMMENT",
	"T_OPEN_TAG",
	"T_OPEN_TAG_WITH_ECHO",
	"T_CLOSE_TAG",
	"T_WHITESPACE",
	"T_START_HEREDOC",
	"T_END_HEREDOC",
	"T_DOLLAR_OPEN_CURLY_BRACES",
	"T_CURLY_OPEN",
	"T_PAAMAYIM_NEKUDOTAYIM",
	"T_NAMESPACE",
	"T_NS_C",
	"T_DIR",
	"T_NS_SEPARATOR",
	"T_ELLIPSIS",
	"T_EVAL",
	"T_REQUIRE",
	"T_REQUIRE_ONCE",
	"T_LOGICAL_OR",
	"T_LOGICAL_XOR",
	"T_LOGICAL_AND",
	"T_INSTANCEOF",
	"T_NEW",
	"T_CLONE",
	"T_ELSEIF",
	"T_ELSE",
	"T_ENDIF",
	"T_PRINT",
	"T_YIELD",
	"T_STATIC",
	"T_ABSTRACT",
	"T_FINAL",
	"T_PRIVATE",
	"T_PROTECTED",
	"T_PUBLIC",
	"T_INC",
	"T_DEC",
	"T_YIELD_FROM",
	"T_INT_CAST",
	"T_DOUBLE_CAST",
	"T_STRING_CAST",
	"T_ARRAY_CAST",
	"T_OBJECT_CAST",
	"T_BOOL_CAST",
	"T_UNSET_CAST",
	"T_COALESCE",
	"T_SPACESHIP",
	"T_NOELSE",
	"'\"'",
	"'`'",
	"'{'",
	"'}'",
	"';'",
	"':'",
	"'('",
	"')'",
	"'['",
	"']'",
	"'?'",
	"'&'",
	"'-'",
	"'+'",
	"'!'",
	"'~'",
	"'@'",
	"'$'",
	"','",
	"'='",
	"T_PLUS_EQUAL",
	"T_MINUS_EQUAL",
	"T_MUL_EQUAL",
	"T_DIV_EQUAL",
	"T_CONCAT_EQUAL",
	"T_MOD_EQUAL",
	"T_AND_EQUAL",
	"T_OR_EQUAL",
	"T_XOR_EQUAL",
	"T_SL_EQUAL",
	"T_SR_EQUAL",
	"T_POW_EQUAL",
	"T_BOOLEAN_OR",
	"T_BOOLEAN_AND",
	"'|'",
	"'^'",
	"T_IS_EQUAL",
	"T_IS_NOT_EQUAL",
	"T_IS_IDENTICAL",
	"T_IS_NOT_IDENTICAL",
	"'<'",
	"T_IS_SMALLER_OR_EQUAL",
	"'>'",
	"T_IS_GREATER_OR_EQUAL",
	"T_SL",
	"T_SR",
	"'.'",
	"'*'",
	"'/'",
	"'%'",
	"T_POW",
}
var yyStatenames = [...]string{}

const yyEofCode = 1
const yyErrCode = 2
const yyInitialStackSize = 16

//line php5/php5.y:1690

//line yacctab:1
var yyExca = [...]int{
	-1, 1,
	1, -1,
	-2, 0,
	-1, 50,
	104, 489,
	105, 489,
	-2, 487,
	-1, 101,
	78, 384,
	123, 367,
	-2, 465,
	-1, 113,
	78, 507,
	123, 503,
	-2, 513,
	-1, 153,
	104, 489,
	105, 489,
	-2, 487,
	-1, 203,
	121, 350,
	124, 350,
	-2, 484,
	-1, 204,
	104, 489,
	105, 489,
	121, 351,
	124, 351,
	-2, 487,
	-1, 227,
	123, 367,
	-2, 384,
	-1, 270,
	78, 507,
	-2, 513,
	-1, 296,
	78, 386,
	123, 371,
	-2, 467,
	-1, 300,
	123, 504,
	-2, 514,
	-1, 309,
	78, 385,
	123, 369,
	-2, 466,
	-1, 371,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 311,
	-1, 372,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 312,
	-1, 373,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 313,
	-1, 374,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 314,
	-1, 375,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 315,
	-1, 376,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 316,
	-1, 377,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 317,
	-1, 378,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 318,
	-1, 385,
	104, 489,
	105, 489,
	-2, 487,
	-1, 416,
	123, 371,
	-2, 386,
	-1, 436,
	123, 498,
	-2, 502,
	-1, 453,
	104, 489,
	105, 489,
	124, 573,
	135, 573,
	-2, 487,
	-1, 454,
	124, 574,
	135, 574,
	-2, 484,
	-1, 455,
	104, 489,
	105, 489,
	-2, 487,
	-1, 477,
	123, 375,
	-2, 505,
	-1, 478,
	123, 528,
	-2, 575,
	-1, 483,
	123, 379,
	-2, 506,
	-1, 484,
	123, 528,
	-2, 576,
	-1, 507,
	78, 384,
	-2, 423,
	-1, 553,
	124, 168,
	-2, 173,
	-1, 561,
	121, 352,
	124, 352,
	-2, 484,
	-1, 562,
	104, 489,
	105, 489,
	121, 353,
	124, 353,
	-2, 487,
	-1, 568,
	123, 369,
	-2, 385,
	-1, 569,
	57, 260,
	125, 260,
	-2, 259,
	-1, 609,
	124, 182,
	135, 182,
	-2, 484,
	-1, 610,
	104, 489,
	105, 489,
	124, 183,
	135, 183,
	-2, 487,
	-1, 659,
	78, 386,
	-2, 425,
	-1, 686,
	124, 168,
	-2, 173,
	-1, 701,
	124, 168,
	-2, 173,
	-1, 768,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 451,
	-1, 769,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 452,
	-1, 770,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 453,
	-1, 771,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 454,
	-1, 772,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 455,
	-1, 773,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 456,
	-1, 774,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 457,
	-1, 775,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 458,
	-1, 778,
	78, 385,
	-2, 424,
	-1, 829,
	57, 255,
	-2, 257,
	-1, 889,
	37, 229,
	-2, 226,
	-1, 951,
	123, 498,
	-2, 502,
	-1, 1017,
	29, 217,
	-2, 4,
	-1, 1043,
	124, 168,
	-2, 173,
	-1, 1047,
	121, 221,
	-2, 223,
}

const yyPrivate = 57344

const yyLast = 8380

var yyAct = [...]int{

	101, 893, 1068, 702, 113, 136, 1011, 114, 436, 122,
	130, 577, 830, 326, 503, 832, 4, 926, 334, 877,
	860, 411, 146, 117, 585, 38, 708, 199, 704, 691,
	608, 823, 452, 714, 803, 680, 60, 661, 465, 412,
	97, 383, 263, 317, 313, 328, 424, 129, 6, 25,
	161, 157, 439, 2, 137, 227, 227, 178, 142, 468,
	43, 327, 191, 288, 5, 631, 1042, 982, 631, 981,
	1005, 42, 1004, 978, 973, 1002, 478, 442, 120, 120,
	266, 257, 998, 980, 270, 152, 964, 271, 586, 1003,
	1053, 191, 873, 999, 824, 631, 717, 566, 818, 633,
	632, 941, 203, 296, 634, 636, 637, 635, 250, 631,
	635, 902, 240, 633, 632, 942, 739, 698, 479, 300,
	269, 685, 566, 200, 502, 309, 496, 740, 314, 318,
	176, 175, 321, 643, 634, 636, 637, 635, 351, 178,
	497, 646, 644, 645, 323, 641, 642, 643, 634, 636,
	637, 635, 191, 484, 333, 120, 782, 492, 696, 38,
	227, 591, 181, 182, 174, 177, 179, 180, 178, 697,
	161, 493, 592, 352, 339, 120, 332, 308, 529, 631,
	846, 657, 639, 633, 632, 443, 443, 353, 240, 350,
	466, 125, 266, 120, 227, 120, 270, 158, 191, 271,
	119, 119, 388, 648, 647, 638, 640, 651, 652, 649,
	650, 653, 655, 654, 656, 641, 642, 643, 634, 636,
	637, 635, 227, 983, 342, 565, 177, 179, 180, 178,
	416, 345, 269, 1023, 379, 950, 566, 176, 175, 208,
	209, 210, 211, 213, 214, 215, 216, 217, 218, 219,
	220, 212, 348, 545, 343, 386, 910, 833, 971, 903,
	228, 227, 443, 229, 546, 909, 349, 440, 344, 447,
	441, 174, 177, 179, 180, 178, 449, 119, 839, 232,
	310, 132, 834, 780, 299, 582, 438, 616, 604, 432,
	298, 581, 227, 603, 311, 133, 597, 119, 596, 240,
	426, 571, 440, 570, 464, 441, 1076, 440, 1059, 729,
	441, 728, 130, 575, 293, 119, 495, 301, 292, 159,
	499, 477, 4, 286, 507, 831, 483, 458, 280, 253,
	252, 38, 1057, 462, 454, 456, 1022, 428, 429, 470,
	471, 990, 876, 871, 524, 480, 868, 866, 849, 1024,
	476, 463, 507, 817, 6, 482, 1072, 431, 741, 491,
	671, 488, 598, 429, 428, 428, 537, 429, 631, 594,
	5, 421, 633, 632, 972, 419, 125, 305, 120, 1043,
	138, 937, 474, 815, 473, 862, 861, 427, 806, 701,
	686, 660, 485, 567, 553, 556, 533, 523, 387, 227,
	653, 655, 654, 656, 641, 642, 643, 634, 636, 637,
	635, 38, 191, 287, 531, 593, 568, 532, 1029, 277,
	274, 555, 440, 440, 294, 441, 441, 208, 209, 210,
	211, 213, 214, 215, 216, 217, 218, 219, 220, 212,
	273, 477, 483, 249, 221, 267, 583, 588, 268, 194,
	440, 176, 175, 441, 193, 440, 141, 561, 441, 121,
	1063, 307, 1062, 306, 232, 988, 958, 795, 796, 587,
	476, 482, 795, 796, 590, 185, 186, 183, 184, 187,
	188, 189, 190, 181, 182, 174, 177, 179, 180, 178,
	381, 331, 134, 1032, 314, 1031, 1021, 987, 318, 965,
	119, 924, 4, 507, 920, 125, 864, 120, 858, 857,
	659, 38, 507, 787, 689, 683, 681, 630, 528, 507,
	507, 507, 507, 507, 607, 487, 390, 341, 155, 103,
	908, 673, 576, 1078, 6, 609, 1050, 962, 623, 936,
	675, 626, 125, 935, 120, 933, 820, 227, 227, 227,
	5, 713, 304, 196, 556, 863, 223, 224, 258, 712,
	794, 556, 956, 430, 613, 266, 881, 227, 682, 270,
	918, 919, 271, 628, 228, 853, 854, 229, 695, 622,
	294, 256, 711, 658, 230, 230, 564, 715, 690, 446,
	415, 414, 124, 232, 440, 125, 1017, 441, 734, 1035,
	125, 227, 665, 227, 125, 269, 718, 716, 125, 264,
	460, 228, 227, 438, 229, 897, 898, 899, 896, 895,
	894, 125, 259, 260, 90, 625, 294, 450, 731, 119,
	232, 501, 507, 507, 507, 507, 507, 507, 507, 507,
	507, 507, 507, 507, 507, 507, 507, 507, 507, 507,
	507, 507, 507, 507, 507, 507, 507, 507, 507, 778,
	737, 507, 738, 459, 557, 557, 119, 558, 558, 730,
	445, 742, 124, 281, 285, 418, 319, 664, 294, 498,
	315, 417, 790, 302, 294, 258, 507, 556, 297, 230,
	801, 804, 494, 131, 227, 320, 38, 792, 779, 507,
	800, 781, 556, 744, 745, 816, 833, 746, 747, 123,
	809, 556, 822, 812, 791, 953, 258, 797, 448, 799,
	227, 264, 125, 230, 631, 61, 262, 639, 633, 632,
	807, 710, 294, 819, 125, 284, 120, 715, 125, 560,
	120, 827, 125, 836, 821, 294, 394, 784, 294, 259,
	260, 230, 651, 652, 649, 650, 653, 655, 654, 656,
	641, 642, 643, 634, 636, 637, 635, 207, 842, 127,
	128, 845, 706, 707, 53, 837, 838, 507, 504, 460,
	259, 260, 206, 507, 507, 1033, 878, 694, 238, 785,
	230, 557, 814, 1069, 558, 258, 454, 700, 162, 258,
	430, 609, 44, 228, 282, 227, 229, 228, 1034, 548,
	229, 527, 1075, 38, 131, 723, 872, 725, 724, 556,
	1041, 230, 232, 44, 1025, 556, 232, 1000, 995, 225,
	233, 975, 258, 938, 869, 1054, 535, 255, 440, 1048,
	1006, 441, 907, 346, 976, 227, 905, 879, 945, 507,
	901, 900, 882, 517, 125, 811, 693, 438, 119, 259,
	260, 891, 119, 259, 260, 749, 748, 892, 916, 629,
	890, 227, 258, 627, 507, 624, 556, 430, 906, 573,
	922, 517, 927, 550, 735, 927, 925, 500, 932, 930,
	915, 944, 929, 556, 472, 38, 259, 260, 865, 795,
	796, 391, 934, 322, 912, 798, 795, 796, 202, 201,
	198, 943, 135, 451, 722, 507, 572, 949, 289, 947,
	719, 897, 898, 899, 896, 895, 894, 437, 230, 961,
	115, 580, 578, 258, 963, 461, 259, 260, 283, 966,
	959, 968, 969, 939, 579, 951, 727, 662, 505, 89,
	948, 100, 514, 506, 952, 957, 911, 841, 440, 589,
	265, 441, 985, 984, 989, 905, 991, 303, 992, 986,
	619, 977, 618, 615, 507, 614, 505, 438, 475, 507,
	490, 556, 295, 556, 38, 970, 38, 88, 1001, 38,
	536, 38, 38, 1007, 392, 254, 284, 259, 260, 75,
	74, 73, 251, 248, 63, 507, 507, 1008, 544, 1016,
	802, 556, 38, 380, 38, 38, 569, 1030, 357, 1026,
	1027, 356, 355, 354, 1036, 825, 444, 721, 720, 904,
	828, 829, 517, 1038, 556, 679, 1047, 1016, 335, 889,
	1046, 517, 1015, 507, 556, 1049, 1044, 1052, 517, 517,
	517, 517, 517, 1014, 556, 1013, 1056, 1051, 1012, 38,
	1045, 1010, 1009, 979, 946, 1061, 1028, 888, 887, 1065,
	1071, 886, 38, 556, 974, 940, 230, 230, 230, 38,
	1058, 885, 631, 884, 1079, 639, 633, 632, 38, 606,
	705, 703, 1018, 955, 264, 923, 230, 960, 870, 1073,
	559, 395, 38, 40, 709, 554, 648, 647, 638, 640,
	651, 652, 649, 650, 653, 655, 654, 656, 641, 642,
	643, 634, 636, 637, 635, 393, 39, 505, 552, 880,
	230, 891, 230, 14, 13, 1077, 505, 892, 1074, 1067,
	890, 230, 874, 505, 505, 505, 505, 505, 208, 209,
	210, 211, 213, 214, 215, 216, 217, 218, 219, 220,
	212, 517, 517, 517, 517, 517, 517, 517, 517, 517,
	517, 517, 517, 517, 517, 517, 517, 517, 517, 517,
	517, 517, 517, 517, 517, 517, 517, 517, 1066, 1064,
	517, 897, 898, 899, 896, 895, 894, 1040, 967, 875,
	813, 699, 808, 549, 195, 631, 382, 657, 639, 633,
	632, 163, 530, 883, 337, 517, 1037, 1019, 921, 678,
	677, 140, 674, 230, 526, 139, 917, 855, 517, 648,
	647, 638, 640, 651, 652, 649, 650, 653, 655, 654,
	656, 641, 642, 643, 634, 636, 637, 635, 789, 230,
	525, 852, 788, 672, 330, 10, 505, 505, 505, 505,
	505, 505, 505, 505, 505, 505, 505, 505, 505, 505,
	505, 505, 505, 505, 505, 505, 505, 505, 505, 505,
	505, 505, 505, 1, 160, 505, 156, 116, 914, 316,
	663, 312, 126, 11, 324, 99, 98, 666, 667, 668,
	669, 670, 78, 118, 512, 3, 517, 0, 0, 0,
	505, 0, 517, 517, 0, 0, 0, 646, 644, 645,
	50, 0, 0, 505, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 230, 0, 0, 0, 0, 0,
	0, 0, 231, 231, 0, 153, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 631, 0, 657, 639, 633,
	632, 0, 204, 0, 0, 0, 0, 272, 0, 0,
	0, 0, 0, 0, 230, 226, 226, 0, 517, 648,
	647, 638, 640, 651, 652, 649, 650, 653, 655, 654,
	656, 641, 642, 643, 634, 636, 637, 635, 0, 0,
	230, 505, 0, 517, 0, 0, 0, 505, 505, 0,
	750, 751, 752, 753, 754, 755, 756, 757, 758, 759,
	760, 761, 762, 763, 764, 765, 766, 767, 768, 769,
	770, 771, 772, 773, 774, 775, 777, 0, 0, 663,
	0, 0, 0, 0, 517, 0, 0, 231, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	30, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 505, 0, 0, 0, 0, 0, 272,
	347, 231, 0, 144, 150, 154, 0, 0, 0, 164,
	0, 0, 0, 0, 0, 0, 0, 197, 505, 0,
	0, 0, 205, 517, 0, 0, 0, 0, 517, 231,
	0, 0, 0, 222, 384, 385, 0, 234, 235, 236,
	237, 0, 0, 239, 0, 241, 242, 243, 244, 245,
	246, 247, 0, 0, 517, 517, 0, 0, 261, 505,
	0, 0, 413, 275, 276, 0, 278, 279, 231, 191,
	0, 0, 0, 0, 0, 847, 0, 290, 0, 0,
	0, 850, 851, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 517, 0, 0, 0, 0, 0, 0, 231,
	0, 435, 0, 0, 0, 0, 0, 547, 176, 175,
	0, 0, 0, 0, 453, 455, 0, 0, 505, 239,
	0, 0, 336, 505, 0, 0, 0, 0, 0, 0,
	0, 0, 469, 0, 0, 0, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 913, 0, 505,
	505, 358, 359, 360, 361, 362, 363, 364, 365, 366,
	367, 368, 369, 370, 371, 372, 373, 374, 375, 376,
	377, 378, 0, 0, 0, 154, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 505, 0, 397,
	399, 400, 401, 402, 403, 404, 405, 406, 407, 408,
	409, 410, 0, 0, 0, 0, 231, 0, 0, 0,
	0, 0, 0, 954, 208, 209, 210, 211, 213, 214,
	215, 216, 217, 218, 219, 220, 212, 0, 0, 0,
	239, 191, 423, 425, 425, 0, 0, 562, 0, 563,
	433, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 154, 154, 0, 0, 457, 0,
	0, 425, 0, 0, 0, 0, 0, 425, 290, 172,
	176, 175, 0, 425, 425, 0, 0, 0, 0, 425,
	481, 0, 0, 0, 0, 486, 0, 0, 0, 0,
	166, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 0,
	0, 0, 0, 0, 0, 610, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 534, 0, 0,
	0, 0, 0, 0, 538, 539, 540, 541, 542, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 231, 231, 231, 0, 0, 0,
	0, 543, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 272, 0, 231, 0, 0, 154, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 384, 692, 692,
	0, 0, 0, 0, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 413, 231, 0,
	231, 0, 0, 0, 0, 0, 0, 0, 0, 231,
	0, 0, 0, 0, 584, 0, 0, 0, 862, 861,
	0, 0, 0, 0, 192, 172, 176, 175, 0, 0,
	0, 469, 0, 469, 646, 644, 645, 599, 601, 0,
	0, 0, 469, 0, 0, 154, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 0, 0, 0, 0, 848,
	0, 0, 631, 0, 657, 639, 633, 632, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 231, 0, 0, 0, 0, 648, 647, 638, 640,
	651, 652, 649, 650, 653, 655, 654, 656, 641, 642,
	643, 634, 636, 637, 635, 688, 0, 231, 0, 0,
	0, 0, 0, 0, 805, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 726, 0, 0, 0,
	413, 0, 425, 732, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 453, 0, 0, 0,
	0, 610, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 743, 0, 0, 0, 840, 0, 0,
	0, 0, 0, 0, 192, 172, 176, 175, 0, 0,
	0, 0, 231, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 692, 0, 0, 0, 0,
	0, 0, 231, 0, 0, 0, 0, 0, 0, 336,
	793, 168, 170, 169, 191, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 231, 0,
	0, 0, 0, 0, 0, 469, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 826, 0,
	835, 192, 172, 176, 175, 0, 0, 0, 0, 425,
	425, 413, 0, 0, 0, 631, 154, 843, 639, 633,
	632, 154, 191, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 640, 651, 652, 649, 650, 653, 655, 654,
	656, 641, 642, 643, 634, 636, 637, 635, 0, 0,
	172, 176, 175, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 859, 0, 0, 0,
	0, 0, 0, 867, 173, 185, 186, 183, 184, 187,
	188, 189, 190, 181, 182, 174, 177, 179, 180, 178,
	82, 83, 71, 17, 104, 105, 12, 87, 120, 0,
	29, 0, 425, 0, 94, 28, 19, 18, 0, 20,
	0, 32, 0, 33, 0, 0, 21, 0, 0, 0,
	22, 23, 37, 44, 15, 24, 35, 0, 0, 36,
	9, 0, 26, 0, 31, 80, 81, 7, 45, 47,
	49, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 8, 112, 108, 102, 0,
	84, 85, 86, 0, 425, 0, 0, 79, 52, 0,
	0, 0, 77, 41, 27, 46, 48, 0, 0, 0,
	54, 55, 336, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 16, 621, 34, 0, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 17, 104, 105, 12, 87, 120,
	0, 29, 0, 0, 0, 94, 28, 19, 18, 0,
	20, 0, 32, 0, 33, 0, 0, 21, 0, 0,
	0, 22, 23, 37, 44, 15, 24, 35, 0, 0,
	36, 9, 0, 26, 0, 31, 80, 81, 7, 45,
	47, 49, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 8, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 41, 27, 46, 48, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 16, 489, 34, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 17, 104, 105, 12, 87,
	120, 0, 29, 0, 0, 0, 94, 28, 19, 18,
	0, 20, 0, 32, 0, 33, 0, 0, 21, 0,
	0, 0, 22, 23, 37, 44, 15, 24, 35, 0,
	0, 36, 9, 0, 26, 0, 31, 80, 81, 7,
	45, 47, 49, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 8, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 41, 27, 46, 48, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 16, 0, 34,
	0, 62, 0, 96, 0, 0, 0, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 17, 104, 105, 12,
	87, 120, 0, 29, 0, 0, 0, 94, 28, 19,
	18, 0, 20, 0, 32, 0, 33, 0, 0, 21,
	0, 0, 0, 22, 23, 37, 44, 0, 24, 35,
	0, 0, 36, 0, 0, 26, 0, 31, 80, 81,
	329, 45, 47, 49, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 41, 27, 46, 48,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 16, 1080,
	34, 0, 62, 0, 96, 0, 0, 0, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 17, 104, 105,
	12, 87, 120, 0, 29, 0, 0, 0, 94, 28,
	19, 18, 0, 20, 0, 32, 0, 33, 0, 0,
	21, 0, 0, 0, 22, 23, 37, 44, 0, 24,
	35, 0, 0, 36, 0, 0, 26, 0, 31, 80,
	81, 329, 45, 47, 49, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 27, 46,
	48, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 16,
	1070, 34, 0, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 17, 104,
	105, 12, 87, 120, 0, 29, 0, 0, 0, 94,
	28, 19, 18, 0, 20, 0, 32, 0, 33, 0,
	0, 21, 0, 0, 0, 22, 23, 37, 44, 0,
	24, 35, 0, 0, 36, 0, 0, 26, 0, 31,
	80, 81, 329, 45, 47, 49, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 41, 27,
	46, 48, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	16, 1060, 34, 0, 62, 0, 96, 0, 0, 0,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 17,
	104, 105, 12, 87, 120, 0, 29, 0, 0, 0,
	94, 28, 19, 18, 0, 20, 1055, 32, 0, 33,
	0, 0, 21, 0, 0, 0, 22, 23, 37, 44,
	0, 24, 35, 0, 0, 36, 0, 0, 26, 0,
	31, 80, 81, 329, 45, 47, 49, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	27, 46, 48, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 16, 0, 34, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	17, 104, 105, 12, 87, 120, 0, 29, 0, 0,
	0, 94, 28, 19, 18, 0, 20, 0, 32, 0,
	33, 0, 0, 21, 0, 0, 0, 22, 23, 37,
	44, 0, 24, 35, 0, 0, 36, 0, 0, 26,
	0, 31, 80, 81, 329, 45, 47, 49, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	41, 27, 46, 48, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 16, 1020, 34, 0, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 17, 104, 105, 12, 87, 120, 0, 29, 0,
	0, 0, 94, 28, 19, 18, 0, 20, 0, 32,
	0, 33, 0, 0, 21, 0, 0, 0, 22, 23,
	37, 44, 0, 24, 35, 0, 0, 36, 0, 0,
	26, 0, 31, 80, 81, 329, 45, 47, 49, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 41, 27, 46, 48, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 16, 997, 34, 0, 62, 0, 96,
	0, 0, 0, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 17, 104, 105, 12, 87, 120, 0, 29,
	0, 0, 0, 94, 28, 19, 18, 0, 20, 0,
	32, 0, 33, 0, 0, 21, 0, 0, 0, 22,
	23, 37, 44, 0, 24, 35, 0, 0, 36, 0,
	0, 26, 0, 31, 80, 81, 329, 45, 47, 49,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 41, 27, 46, 48, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 16, 996, 34, 0, 62, 0,
	96, 0, 0, 0, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 17, 104, 105, 12, 87, 120, 0,
	29, 0, 0, 0, 94, 28, 19, 18, 0, 20,
	0, 32, 0, 33, 0, 0, 21, 0, 0, 0,
	22, 23, 37, 44, 0, 24, 35, 0, 0, 36,
	0, 0, 26, 0, 31, 80, 81, 329, 45, 47,
	49, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 41, 27, 46, 48, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 16, 994, 34, 0, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 17, 104, 105, 12, 87, 120,
	0, 29, 0, 0, 0, 94, 28, 19, 18, 0,
	20, 0, 32, 993, 33, 0, 0, 21, 0, 0,
	0, 22, 23, 37, 44, 0, 24, 35, 0, 0,
	36, 0, 0, 26, 0, 31, 80, 81, 329, 45,
	47, 49, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 41, 27, 46, 48, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 16, 0, 34, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 17, 104, 105, 12, 87,
	120, 0, 29, 0, 0, 0, 94, 28, 19, 18,
	0, 20, 0, 32, 0, 33, 931, 0, 21, 0,
	0, 0, 22, 23, 37, 44, 0, 24, 35, 0,
	0, 36, 0, 0, 26, 0, 31, 80, 81, 329,
	45, 47, 49, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 41, 27, 46, 48, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 16, 0, 34,
	0, 62, 0, 96, 0, 0, 0, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 17, 104, 105, 12,
	87, 120, 0, 29, 0, 0, 0, 94, 28, 19,
	18, 856, 20, 0, 32, 0, 33, 0, 0, 21,
	0, 0, 0, 22, 23, 37, 44, 0, 24, 35,
	0, 0, 36, 0, 0, 26, 0, 31, 80, 81,
	329, 45, 47, 49, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 41, 27, 46, 48,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 16, 0,
	34, 0, 62, 0, 96, 0, 0, 0, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 17, 104, 105,
	12, 87, 120, 0, 29, 0, 0, 0, 94, 28,
	19, 18, 0, 20, 0, 32, 0, 33, 0, 0,
	21, 0, 0, 0, 22, 23, 37, 44, 0, 24,
	35, 0, 0, 36, 0, 0, 26, 0, 31, 80,
	81, 329, 45, 47, 49, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 27, 46,
	48, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 16,
	551, 34, 0, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 17, 104,
	105, 12, 87, 120, 0, 29, 0, 0, 0, 94,
	28, 19, 18, 0, 20, 0, 32, 0, 33, 0,
	0, 21, 0, 0, 0, 22, 23, 37, 44, 0,
	24, 35, 0, 0, 36, 0, 0, 26, 0, 31,
	80, 81, 329, 45, 47, 49, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 41, 27,
	46, 48, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	16, 325, 34, 0, 62, 0, 96, 0, 0, 0,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 17,
	104, 105, 12, 87, 120, 0, 29, 0, 0, 0,
	94, 28, 19, 18, 0, 20, 0, 32, 0, 33,
	0, 0, 21, 0, 0, 0, 22, 23, 37, 44,
	0, 24, 35, 0, 0, 36, 0, 0, 26, 0,
	31, 80, 81, 329, 45, 47, 49, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	27, 46, 48, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 16, 0, 34, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	17, 104, 105, 12, 87, 120, 0, 29, 0, 0,
	0, 94, 28, 19, 18, 0, 20, 0, 32, 0,
	33, 0, 0, 21, 0, 0, 0, 22, 23, 37,
	44, 0, 24, 35, 0, 0, 36, 0, 0, 26,
	0, 31, 80, 81, 0, 0, 0, 0, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	41, 27, 0, 0, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 16, 0, 34, 1039, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 17, 104, 105, 12, 87, 120, 0, 29, 0,
	0, 0, 94, 28, 19, 18, 0, 20, 0, 32,
	0, 33, 0, 0, 21, 0, 0, 0, 22, 23,
	37, 44, 0, 24, 35, 0, 0, 36, 0, 0,
	26, 0, 31, 80, 81, 0, 0, 0, 0, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 41, 27, 0, 0, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 16, 0, 34, 928, 62, 0, 96,
	0, 0, 0, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 17, 104, 105, 12, 87, 120, 0, 29,
	0, 0, 0, 94, 28, 19, 18, 0, 20, 0,
	32, 0, 33, 0, 0, 21, 0, 0, 0, 22,
	23, 37, 44, 0, 24, 35, 0, 0, 36, 0,
	0, 26, 0, 31, 80, 81, 0, 0, 0, 0,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 41, 27, 0, 0, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 16, 0, 34, 810, 62, 0,
	96, 0, 0, 0, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 17, 104, 105, 12, 87, 120, 0,
	29, 0, 0, 0, 94, 28, 19, 18, 0, 20,
	0, 32, 0, 33, 0, 0, 21, 0, 0, 0,
	22, 23, 37, 44, 0, 24, 35, 0, 0, 36,
	0, 0, 26, 0, 31, 80, 81, 0, 0, 0,
	0, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 41, 27, 0, 0, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 16, 0, 34, 676, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 17, 104, 105, 12, 87, 120,
	0, 29, 0, 0, 0, 94, 28, 19, 18, 0,
	20, 0, 32, 0, 33, 0, 0, 21, 0, 0,
	0, 22, 23, 37, 44, 0, 24, 35, 0, 0,
	36, 0, 0, 26, 0, 31, 80, 81, 0, 0,
	0, 0, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 41, 27, 646, 644, 645, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 783, 0, 0, 91, 76, 16, 0, 34, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 0, 786, 631, 0, 657, 639, 633, 632,
	646, 644, 645, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 736, 0, 0, 648, 647,
	638, 640, 651, 652, 649, 650, 653, 655, 654, 656,
	641, 642, 643, 634, 636, 637, 635, 0, 631, 0,
	657, 639, 633, 632, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 648, 647, 638, 640, 651, 652, 649, 650,
	653, 655, 654, 656, 641, 642, 643, 634, 636, 637,
	635, 0, 0, 0, 192, 172, 176, 175, 0, 0,
	0, 0, 168, 170, 169, 191, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 733, 0, 0, 0, 0,
	0, 0, 192, 172, 176, 175, 0, 0, 168, 170,
	169, 191, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 166, 167, 171, 173, 185, 186,
	183, 184, 187, 188, 189, 190, 181, 182, 174, 177,
	179, 180, 178, 687, 0, 0, 0, 0, 192, 172,
	176, 175, 0, 0, 0, 0, 168, 170, 169, 191,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	166, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 684,
	0, 0, 0, 0, 0, 0, 192, 172, 176, 175,
	0, 0, 0, 0, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 166, 167,
	171, 173, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 620, 0, 0,
	0, 0, 0, 0, 192, 172, 176, 175, 0, 0,
	0, 0, 168, 170, 169, 191, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 617, 0, 0, 0, 0,
	0, 0, 192, 172, 176, 175, 168, 170, 169, 191,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 166, 167, 171, 173, 185, 186,
	183, 184, 187, 188, 189, 190, 181, 182, 174, 177,
	179, 180, 178, 595, 0, 0, 192, 172, 176, 175,
	0, 0, 0, 0, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 166, 167,
	171, 173, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 574, 0, 0,
	0, 0, 0, 0, 192, 172, 176, 175, 0, 0,
	0, 0, 0, 0, 0, 0, 467, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 168, 170, 169, 191, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 192, 172, 176, 175, 168,
	170, 169, 191, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 396, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 420, 0, 0, 192,
	172, 176, 175, 168, 170, 169, 191, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 166, 167, 171, 173, 185, 186, 183, 184, 187,
	188, 189, 190, 181, 182, 174, 177, 179, 180, 178,
	0, 0, 0, 192, 172, 176, 175, 0, 0, 0,
	168, 170, 169, 191, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 166, 167, 171, 173, 185,
	186, 183, 184, 187, 188, 189, 190, 181, 182, 174,
	177, 179, 180, 178, 389, 0, 0, 0, 0, 0,
	192, 172, 176, 175, 0, 0, 0, 168, 170, 169,
	191, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 166, 167, 171, 173, 185, 186, 183, 184,
	187, 188, 189, 190, 181, 182, 174, 177, 179, 180,
	178, 340, 0, 0, 0, 0, 0, 192, 172, 176,
	175, 0, 0, 0, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 338, 0,
	0, 0, 0, 0, 192, 172, 176, 175, 0, 0,
	0, 168, 170, 169, 191, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 165, 0, 0, 0, 0,
	0, 192, 172, 176, 175, 646, 644, 645, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 0, 631, 0, 657, 639, 633, 632, 168,
	170, 169, 191, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 648, 647, 638,
	640, 651, 652, 649, 650, 653, 655, 654, 656, 641,
	642, 643, 634, 636, 637, 635, 0, 0, 0, 192,
	172, 176, 175, 644, 645, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 166, 167, 171, 173, 185, 186, 183, 184, 187,
	188, 189, 190, 181, 182, 174, 177, 179, 180, 178,
	631, 0, 657, 639, 633, 632, 170, 169, 191, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 648, 647, 638, 640, 651, 652,
	649, 650, 653, 655, 654, 656, 641, 642, 643, 634,
	636, 637, 635, 0, 0, 192, 172, 176, 175, 0,
	645, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 631, 0, 657, 639,
	633, 632, 169, 191, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	648, 647, 638, 640, 651, 652, 649, 650, 653, 655,
	654, 656, 641, 642, 643, 634, 636, 637, 635, 0,
	192, 172, 176, 175, 191, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 166, 167, 171, 173, 185, 186, 183, 184,
	187, 188, 189, 190, 181, 182, 174, 177, 179, 180,
	178, 192, 172, 176, 175, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 631, 0, 0,
	639, 633, 632, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 647, 638, 640, 651, 652, 649, 650, 653,
	655, 654, 656, 641, 642, 643, 634, 636, 637, 635,
	191, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 172, 176,
	175, 0, 0, 0, 0, 82, 83, 71, 0, 104,
	105, 125, 87, 120, 0, 0, 0, 0, 0, 94,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 44, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	80, 81, 0, 0, 0, 0, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 612, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 41, 147,
	0, 0, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 631, 91, 76,
	639, 633, 632, 0, 62, 605, 96, 0, 0, 611,
	57, 56, 58, 59, 72, 119, 0, 0, 0, 0,
	0, 0, 0, 638, 640, 651, 652, 649, 650, 653,
	655, 654, 656, 641, 642, 643, 634, 636, 637, 635,
	82, 83, 71, 0, 104, 105, 125, 87, 120, 0,
	0, 0, 0, 0, 94, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 44, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 80, 81, 0, 0, 0,
	0, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 191, 0, 0, 148, 112, 108, 102, 612,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 145, 147, 0, 0, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	172, 176, 175, 91, 76, 0, 0, 0, 0, 62,
	0, 96, 0, 0, 611, 57, 56, 58, 59, 72,
	119, 0, 0, 171, 173, 185, 186, 183, 184, 187,
	188, 189, 190, 181, 182, 174, 177, 179, 180, 178,
	82, 83, 71, 0, 104, 105, 125, 87, 120, 0,
	0, 0, 0, 0, 94, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 44, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 80, 81, 0, 0, 0,
	0, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 145, 147, 0, 0, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 0, 0, 0, 631, 62,
	0, 96, 633, 632, 844, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 0, 104, 105, 125, 87, 120,
	0, 0, 0, 0, 0, 94, 651, 652, 649, 650,
	653, 655, 654, 656, 641, 642, 643, 634, 636, 637,
	635, 0, 0, 0, 44, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 80, 81, 0, 0,
	0, 0, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 145, 147, 0, 0, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 0, 0, 0, 0,
	62, 0, 96, 0, 0, 602, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 0, 104, 105, 125, 87,
	120, 0, 0, 0, 0, 0, 94, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 44, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 80, 81, 0,
	0, 0, 0, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 145, 147, 0, 0, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 0, 0, 0,
	0, 62, 0, 96, 0, 0, 600, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 0, 104, 105, 125,
	87, 120, 0, 0, 0, 0, 0, 94, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 44, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 80, 81,
	0, 0, 0, 0, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 145, 147, 0, 0,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 0, 0,
	0, 0, 62, 0, 96, 0, 0, 291, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 0, 104, 105,
	125, 87, 120, 0, 0, 0, 0, 0, 94, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 44, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 80,
	81, 0, 0, 0, 0, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 191, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 147, 0,
	0, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 0,
	0, 0, 0, 62, 422, 96, 172, 176, 175, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 0, 104,
	105, 125, 87, 120, 0, 0, 0, 0, 0, 94,
	0, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 0, 0, 44, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	80, 81, 0, 0, 0, 0, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 145, 147,
	0, 0, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	0, 0, 0, 0, 62, 0, 96, 0, 0, 398,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 0,
	104, 105, 125, 87, 120, 0, 0, 0, 0, 0,
	94, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 44,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 80, 81, 0, 0, 0, 0, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 145,
	147, 0, 0, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 0, 0, 151, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	0, 104, 105, 125, 87, 120, 0, 0, 0, 0,
	0, 94, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	44, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 80, 81, 0, 0, 0, 0, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	145, 147, 0, 0, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 0, 0, 149, 0, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 0, 104, 105, 125, 87, 120, 0, 0, 0,
	0, 0, 94, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 44, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 80, 81, 0, 0, 0, 0, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 145, 147, 0, 0, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 0, 0, 143, 0, 62, 0, 96,
	0, 0, 0, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 0, 104, 105, 125, 87, 120, 0, 0,
	0, 0, 0, 94, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 44, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 80, 81, 0, 0, 0, 0,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 145, 147, 0, 0, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 0, 0, 0, 0, 62, 0,
	96, 0, 0, 0, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 0, 104, 105, 125, 434, 120, 0,
	0, 0, 0, 0, 94, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 44, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 80, 81, 0, 0, 0,
	0, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 145, 147, 0, 0, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 0, 0, 0, 0, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 0, 104, 105, 125, 87, 120,
	0, 0, 0, 0, 0, 94, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 44, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 80, 81, 0, 0,
	0, 0, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	104, 105, 125, 77, 41, 147, 0, 0, 0, 0,
	515, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 0, 0, 0, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 510, 0, 513, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 516, 0, 0, 0,
	0, 508, 112, 108, 509, 104, 105, 125, 0, 0,
	0, 0, 0, 0, 0, 515, 0, 0, 0, 0,
	232, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 776, 522, 0, 511, 0, 0,
	0, 521, 520, 518, 519, 0, 0, 510, 0, 513,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 516, 0, 0, 0, 0, 508, 112, 108, 509,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 232, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	522, 0, 511, 0, 0, 0, 521, 520, 518, 519,
}
var yyPact = [...]int{

	-1000, -1000, 2538, -1000, -1000, -1000, -1000, 336, 590, 732,
	160, -1000, 370, -1000, -1000, 902, -1000, 257, -1000, -1000,
	333, 257, 7694, 7563, 7432, 407, 185, 786, 7825, -1000,
	5814, 331, 326, -1000, -1000, 434, 7825, 900, -5, 899,
	898, 7825, -1000, -1000, -1000, -1000, 730, -1000, 715, -1000,
	1012, 321, 7825, 452, 181, 181, 7825, 7825, 7825, 7825,
	-1000, -1000, 8087, -1000, 7825, 7825, 7825, 7825, 7825, 7825,
	7825, 320, -1000, -1000, 205, 204, 820, 7825, 669, 366,
	317, 297, 7825, 7825, 296, 7825, 7825, -1000, 203, -1000,
	-1000, 787, 921, -1000, 198, 290, 7039, -1000, 193, 189,
	-1000, 498, 844, 610, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, 165, 183, -1000, 605, -1000, -1000, 433,
	-1000, 253, 342, -1000, 844, -1000, 159, 598, 594, -1000,
	666, 844, -1000, 893, -1000, 8, 4241, 369, 8087, 257,
	5027, 7825, -1000, -1000, 5767, -1000, -5, 765, 510, -1000,
	5720, -1000, 406, 103, 5902, -1000, 133, -1000, -1000, 724,
	131, -5, 2, 52, 5902, -1000, -1000, -1000, -1000, -1000,
	7825, 7825, 7825, 7825, 7825, 7825, 7825, 7825, 7825, 7825,
	7825, 7825, 7825, 7825, 7825, 7825, 7825, 7825, 7825, 7825,
	7825, 366, 368, 181, 7825, 275, -1000, 5673, 405, 891,
	-1000, 691, -1000, -1000, 1012, 5626, -1000, -1000, 7301, 7825,
	7825, 7825, 7825, 7825, 7825, 7825, 7825, 7825, 7825, 7825,
	7825, 532, -1000, -1000, -1000, -1000, -1000, 498, 508, 844,
	603, 597, -1000, -1000, -110, -110, -28, -110, 251, 5582,
	247, -110, -110, -110, -110, -110, -110, -110, -1000, 7170,
	-1000, 7825, 7825, 7825, 269, 673, 783, -1000, 232, 7956,
	181, 6114, 67, -1000, 592, -1000, 498, 507, 844, 661,
	165, 183, 549, 7825, 7825, 5902, 5902, 7825, 5902, 5902,
	7825, 546, 673, 704, -1000, 860, 7825, 7039, 178, 55,
	5538, 181, 7825, 7825, 884, 259, 498, 66, 7825, 7825,
	165, 433, 143, 259, 7825, 404, -1000, -1000, 2407, 498,
	-1000, 611, 36, -1000, 663, 844, 5, -1000, 650, 844,
	877, 602, -12, 8247, -1000, -1000, -1000, -1000, -1000, 274,
	5027, -1000, -1000, 790, 397, 43, 5902, 295, -1000, -1000,
	-1000, -1000, -1000, -1000, 185, -1000, 7825, -1000, -1000, 824,
	-1000, 8247, -1000, 7825, 7825, 7825, 7825, 7825, 6073, 2112,
	322, 7168, 62, 62, 62, -28, -110, -28, -28, 108,
	108, 1459, 1459, 1459, 1459, 1, 1, 1, 1, -1000,
	7825, -1000, 129, -1000, -1000, 1558, 780, 873, 4110, -1000,
	-1000, -1000, 271, -1000, 585, 684, 7825, 6114, 495, 6114,
	6114, 6114, 6114, 6114, 6114, 6114, 6114, 6114, 6114, 6114,
	6114, 101, -1000, -1000, 270, 844, 498, 67, 67, -1000,
	-1000, -1000, -1000, -110, 177, 5902, 175, -1000, -1000, -1000,
	-1000, -1000, 869, 5457, 188, 412, -1000, 166, -1000, -1000,
	165, 183, -1000, 7825, 259, 163, 844, 498, -1000, 165,
	163, 37, -1000, 1012, -1000, 291, 245, 5409, 172, -1000,
	-1000, -1000, 170, 238, -1000, -1000, 6908, 6777, -1000, -1000,
	167, 162, -1000, -1000, 6341, 259, -1000, -1000, -1000, -1000,
	161, 5365, -1000, -1000, -1000, -1000, 5317, -1000, 2276, -1000,
	259, -1000, -1000, 598, 865, 596, -1000, 594, 863, 544,
	-1000, 859, 8247, -1000, 5858, -1000, -1000, 498, 501, 844,
	268, 8247, -1000, -1000, -1000, -1000, 660, 524, 8247, 8247,
	8247, 8247, 8247, 236, -1000, -1000, 4896, -1000, -1000, -1000,
	-1000, 395, 394, -1000, 5269, -15, 267, -1000, 5902, 6210,
	6482, 5988, 6114, 5221, 7825, 393, 181, 728, 728, 34,
	-19, 756, 266, 712, 675, -1000, 498, 500, 844, 432,
	585, -1000, 1012, -1000, 366, -40, 532, -1000, 498, -1000,
	-1000, -1000, 805, -1000, -1000, 7825, -1000, -1000, 186, 184,
	259, 7825, 7825, 165, 5175, -1000, -1000, -1000, 498, 67,
	-1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, 5127,
	181, 5902, 181, -1000, -1000, -1000, -8, 234, -1000, -1000,
	1012, 181, 7825, -1000, 259, 259, -1000, -1000, 259, 259,
	-1000, -1000, -1000, -1000, -1000, 856, -1000, -1000, 855, -1000,
	-1000, 8247, 8247, 8247, 8247, 8247, 8247, 8247, 8247, 8247,
	8247, 8247, 8247, 8247, 8247, 8247, 8247, 8247, 8247, 8247,
	8247, 8247, 8247, 8247, 8247, 8247, 8247, 8172, 844, 498,
	8247, 157, 21, 5083, 535, 737, -57, -57, -60, -60,
	5039, 392, -1000, 4372, -1000, -1000, -1000, 257, 7825, 7825,
	440, -1000, 874, -1000, -1000, 8247, 712, -1000, 1621, -1000,
	-1000, 633, -1000, 181, 265, 633, 4765, 845, 8247, 750,
	260, 712, 229, -37, -1000, -5, -1000, -1000, -1000, 427,
	585, 844, 498, -1000, -41, -1000, -1000, 7825, -1000, 532,
	-1000, 200, 156, -1000, -1000, -1000, 2054, 649, 7825, 7825,
	-1000, 152, 1957, -1000, -1000, 7825, 6646, -1000, -1000, -1000,
	6496, -1000, -1000, 5902, -1000, -1000, -1000, -1000, -1000, -1000,
	54, -60, -60, -57, -57, -57, -57, 2070, 6643, 599,
	-30, -30, -60, 6031, 1080, 5945, 6332, 6132, 243, 243,
	243, 243, -16, -16, -16, -16, 8247, 1837, 498, 224,
	-1000, -1000, 8247, 8247, -1000, -1000, -1000, -1000, 482, -1000,
	3979, 388, 387, 5902, -1000, 7825, 264, 435, 385, 867,
	-1000, 223, 7825, 222, 728, -1000, -1000, 219, -1000, -1000,
	-1000, -44, -1000, -1000, -1000, -1000, 218, 742, 712, 483,
	-1000, -41, 498, 1093, 585, 259, 6114, -13, -1000, 134,
	649, 7825, -1000, 67, -1000, 410, -1000, 139, 130, -1000,
	-1000, -1000, -1000, 5902, 181, -1000, -1000, 957, 8247, -1000,
	1230, 5858, -1000, 257, 5027, 477, 383, -1000, -1000, 1787,
	-1000, -1000, -1000, -1000, -1000, 380, 742, 1621, 4634, -1000,
	532, 4634, 3848, 8247, 426, 585, 424, 420, 258, -1000,
	821, -1000, 823, -1000, -1000, -1000, -20, -1000, 765, 517,
	-1000, 838, 585, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, 7825, 649, -1000, 109, -1000, -1000, -1000,
	-1000, 658, -1000, 957, 8247, -1000, -1000, 467, 257, 344,
	-1000, 7825, -1000, -1000, -1000, 418, -1000, -1000, -1000, -38,
	-1000, 378, -1000, -1000, -1000, -1000, -1000, 246, -62, -1000,
	819, -1000, 834, -5, -1000, -63, -52, -1000, 97, 649,
	-1000, -1000, -1000, 67, 5858, 5027, 376, 343, -1000, 217,
	-1000, 4372, -1000, 3717, -1000, -1000, 3586, 816, 3455, 3324,
	-42, -1000, 815, 8247, -46, -64, -66, 830, 8247, -1000,
	585, -1000, 586, -1000, -1000, -1000, -1000, -1000, -1000, 4372,
	-1000, 4372, 3193, 375, -1000, 212, -1000, -1000, -1000, 221,
	-1000, -1000, -1000, 812, 8247, 8247, -1000, -1000, -1000, 298,
	586, -1000, 374, 372, 740, 779, 521, -1000, -1000, 4503,
	-1000, -1000, -1000, -1000, 808, -70, -1000, -1000, 256, -1000,
	-1000, -1000, -1000, 585, 517, 829, 4372, -1000, -1000, -1000,
	417, -1000, 8247, 712, -45, -1000, 825, -1000, -1000, 3062,
	-1000, -1000, 208, 585, -1000, 187, 2931, 341, -1000, -1000,
	-1000, -1000, -1000, -1000, 752, 2800, -1000, 752, -1000, 233,
	-1000, -1000, 585, -1000, 800, 182, -1000, 414, -1000, 2669,
	-1000,
}
var yyPgo = [...]int{

	0, 1305, 47, 44, 43, 624, 1304, 1303, 4, 529,
	1287, 46, 1460, 60, 71, 59, 774, 1320, 1302, 40,
	1296, 1295, 1294, 13, 1293, 51, 14, 53, 0, 1292,
	1291, 1289, 5, 1286, 1284, 7, 1283, 61, 45, 1255,
	36, 1254, 1253, 1252, 1251, 1250, 1248, 1227, 1226, 1225,
	1224, 1222, 1221, 1220, 18, 1219, 1218, 1217, 1216, 1214,
	1212, 49, 1211, 1206, 29, 34, 17, 1204, 1203, 1202,
	1201, 1200, 1199, 26, 1198, 1197, 1189, 1188, 1142, 1139,
	2, 1138, 1135, 41, 1134, 1133, 27, 1129, 22, 1128,
	3, 1126, 1125, 1105, 1104, 31, 1103, 1101, 1100, 33,
	1098, 21, 35, 20, 1097, 1095, 1093, 1092, 1091, 28,
	1090, 88, 1089, 30, 1083, 1081, 1075, 1074, 1071, 1068,
	1067, 1066, 1065, 1064, 1063, 1062, 1061, 6, 1058, 1055,
	1053, 1046, 1042, 1040, 1, 1039, 1038, 1035, 12, 15,
	1031, 1030, 1029, 1028, 1027, 725, 42, 1026, 24, 1025,
	1023, 1022, 1021, 1018, 1016, 1013, 1010, 1008, 1004, 1003,
	1002, 1001, 1000, 999, 995, 994, 19, 990, 987, 63,
	985, 982, 980, 978, 52, 975, 23, 973, 972, 970,
	967, 960, 959, 8, 957, 956, 954, 581, 778, 953,
	37, 952, 951, 949, 947, 38, 11, 946, 945, 944,
	932, 931, 930, 927, 39, 920, 918, 81, 916, 914,
	913, 32, 884,
}
var yyR1 = [...]int{

	0, 36, 27, 27, 28, 28, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 29, 29, 2,
	2, 2, 2, 30, 30, 3, 3, 3, 3, 31,
	31, 4, 4, 4, 4, 39, 39, 32, 32, 22,
	22, 22, 22, 23, 23, 24, 41, 42, 24, 45,
	46, 24, 49, 50, 24, 52, 53, 24, 55, 56,
	57, 24, 59, 24, 24, 24, 24, 24, 24, 24,
	24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
	67, 24, 24, 24, 24, 24, 70, 72, 74, 75,
	76, 70, 71, 78, 71, 77, 77, 79, 79, 81,
	82, 80, 63, 63, 83, 37, 38, 86, 86, 87,
	87, 89, 84, 93, 85, 97, 85, 91, 91, 91,
	91, 92, 92, 96, 98, 98, 94, 94, 99, 99,
	65, 65, 64, 64, 100, 64, 58, 58, 66, 66,
	69, 69, 68, 68, 60, 60, 60, 60, 102, 104,
	102, 105, 102, 103, 103, 51, 51, 43, 106, 43,
	47, 107, 47, 44, 44, 48, 48, 90, 90, 108,
	108, 109, 109, 110, 110, 110, 110, 111, 111, 111,
	112, 112, 113, 113, 113, 113, 33, 33, 25, 25,
	25, 34, 34, 34, 34, 95, 95, 116, 114, 114,
	114, 121, 114, 119, 123, 123, 124, 124, 125, 125,
	126, 126, 127, 127, 128, 131, 131, 132, 132, 130,
	129, 129, 133, 133, 122, 122, 115, 115, 120, 120,
	135, 135, 134, 134, 134, 134, 134, 134, 117, 117,
	117, 117, 118, 118, 62, 62, 54, 54, 137, 136,
	136, 138, 138, 140, 140, 142, 141, 141, 141, 143,
	144, 143, 147, 145, 13, 13, 13, 149, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 13, 13, 13, 13, 150, 13, 151, 13,
	152, 13, 153, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 154, 13, 155, 156, 13, 157, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 160, 13,
	13, 13, 13, 13, 13, 13, 165, 13, 167, 13,
	61, 61, 61, 61, 162, 162, 162, 162, 163, 163,
	88, 166, 166, 170, 170, 170, 170, 171, 21, 172,
	21, 173, 21, 175, 21, 177, 21, 178, 21, 179,
	21, 180, 21, 9, 9, 9, 9, 73, 73, 73,
	146, 146, 182, 184, 181, 181, 185, 185, 186, 159,
	159, 159, 164, 164, 164, 148, 148, 5, 5, 5,
	5, 5, 5, 5, 5, 5, 5, 5, 5, 6,
	26, 188, 188, 188, 188, 188, 188, 188, 188, 188,
	188, 191, 191, 191, 191, 191, 191, 191, 191, 191,
	191, 191, 191, 191, 191, 191, 191, 191, 191, 191,
	191, 191, 191, 191, 191, 191, 191, 191, 191, 191,
	191, 191, 191, 191, 168, 168, 168, 168, 161, 161,
	161, 161, 161, 161, 161, 190, 190, 195, 195, 194,
	194, 194, 194, 12, 12, 40, 40, 14, 15, 16,
	17, 17, 197, 197, 198, 139, 199, 199, 201, 200,
	196, 196, 196, 176, 176, 202, 202, 10, 20, 20,
	18, 18, 18, 19, 19, 19, 8, 8, 8, 7,
	7, 11, 11, 183, 183, 203, 203, 203, 174, 174,
	35, 35, 101, 101, 204, 205, 204, 204, 169, 169,
	206, 206, 206, 206, 206, 206, 206, 206, 187, 187,
	187, 187, 207, 208, 207, 207, 207, 207, 207, 209,
	209, 209, 158, 158, 158, 158, 158, 158, 158, 158,
	210, 212, 210, 211, 211, 192, 192, 189, 193,
}
var yyR2 = [...]int{

	0, 1, 2, 0, 1, 3, 1, 1, 1, 4,
	3, 5, 4, 3, 4, 4, 2, 3, 1, 1,
	3, 2, 4, 3, 1, 1, 3, 2, 4, 3,
	1, 1, 3, 2, 4, 5, 4, 2, 0, 1,
	1, 1, 4, 1, 2, 3, 0, 0, 7, 0,
	0, 10, 0, 0, 5, 0, 0, 7, 0, 0,
	0, 12, 0, 4, 2, 3, 2, 3, 2, 3,
	3, 2, 3, 3, 3, 1, 2, 5, 8, 8,
	0, 6, 1, 6, 3, 3, 0, 0, 0, 0,
	0, 13, 0, 0, 5, 1, 0, 1, 2, 0,
	0, 10, 1, 3, 1, 1, 1, 0, 1, 0,
	1, 0, 10, 0, 8, 0, 7, 1, 2, 1,
	2, 0, 2, 1, 0, 2, 0, 2, 1, 3,
	0, 2, 1, 2, 0, 5, 1, 4, 1, 4,
	1, 4, 3, 5, 3, 4, 4, 5, 0, 0,
	6, 0, 5, 1, 1, 1, 4, 0, 0, 5,
	0, 0, 6, 0, 2, 0, 3, 1, 0, 1,
	3, 4, 6, 0, 1, 1, 1, 2, 3, 3,
	1, 3, 1, 1, 2, 2, 3, 1, 1, 2,
	4, 3, 5, 1, 3, 2, 0, 0, 4, 2,
	1, 0, 9, 3, 1, 3, 1, 3, 0, 1,
	1, 2, 2, 2, 3, 1, 3, 1, 1, 3,
	4, 3, 0, 1, 1, 3, 1, 1, 0, 1,
	1, 2, 1, 1, 1, 1, 1, 1, 3, 5,
	1, 3, 5, 4, 3, 1, 0, 1, 0, 4,
	1, 2, 1, 4, 3, 0, 3, 1, 1, 0,
	0, 2, 0, 4, 6, 3, 4, 0, 7, 2,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 2, 2, 2, 2, 0, 4, 0, 4,
	0, 4, 0, 4, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 2, 2, 2,
	2, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	1, 1, 0, 5, 0, 0, 7, 0, 5, 1,
	2, 2, 2, 2, 2, 2, 2, 2, 0, 3,
	1, 1, 1, 3, 2, 1, 0, 10, 0, 11,
	2, 2, 4, 4, 4, 4, 4, 4, 4, 3,
	1, 0, 4, 3, 4, 1, 2, 0, 3, 0,
	5, 0, 4, 0, 5, 0, 5, 0, 5, 0,
	5, 0, 3, 1, 1, 3, 2, 1, 3, 2,
	1, 1, 0, 0, 6, 1, 2, 0, 2, 0,
	2, 1, 0, 1, 1, 0, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 3, 2, 3,
	1, 1, 1, 1, 3, 2, 4, 3, 1, 1,
	1, 4, 3, 3, 3, 3, 3, 3, 2, 2,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
	5, 2, 2, 3, 1, 1, 3, 2, 1, 1,
	1, 1, 3, 3, 1, 0, 2, 0, 1, 5,
	3, 3, 1, 1, 1, 3, 3, 1, 1, 1,
	5, 1, 2, 0, 0, 4, 4, 4, 0, 2,
	1, 1, 0, 1, 2, 3, 3, 1, 4, 4,
	1, 1, 1, 1, 2, 1, 4, 4, 1, 1,
	4, 0, 1, 1, 1, 4, 4, 1, 1, 3,
	1, 2, 3, 1, 1, 0, 5, 0, 0, 2,
	5, 3, 3, 1, 6, 4, 4, 2, 2, 2,
	1, 2, 1, 0, 5, 3, 3, 6, 3, 1,
	1, 1, 4, 4, 4, 2, 2, 4, 2, 2,
	1, 0, 4, 1, 1, 3, 3, 3, 3,
}
var yyChk = [...]int{

	-1000, -36, -27, -1, -23, -37, -38, 51, 79, 44,
	-39, -24, 10, -84, -85, 38, 119, 7, 21, 20,
	23, 30, 34, 35, 39, -61, 46, 98, 19, 14,
	-12, 48, 25, 27, 121, 40, 43, 36, -88, -91,
	-96, 97, -14, -13, 37, 52, 99, 53, 100, 54,
	-17, 59, 92, -16, 104, 105, 130, 129, 131, 132,
	-40, -145, 123, -158, 107, 108, 109, 110, 111, 112,
	113, 6, 133, -161, -162, -163, 118, 96, -18, 91,
	49, 50, 4, 5, 84, 85, 86, 11, -168, -193,
	-5, 117, 74, 62, 18, 60, 125, -19, -20, -21,
	-192, -28, 82, -9, 8, 9, 66, 67, 81, 63,
	64, 65, 80, -8, -35, -202, -10, -176, -7, 134,
	12, 123, -28, 119, 82, 10, -29, 37, 38, -2,
	-28, 82, 121, 135, 122, 10, -32, -40, 123, -49,
	-52, 123, -40, 121, -12, 97, -88, 98, 79, 121,
	-12, 121, -13, -17, -12, 121, -33, -25, 12, 134,
	-34, -88, 12, -62, -12, 121, 149, 150, 87, 89,
	88, 151, 128, 152, 163, 130, 129, 164, 167, 165,
	166, 161, 162, 155, 156, 153, 154, 157, 158, 159,
	160, 90, 127, 123, 123, -67, 119, -12, 10, -86,
	128, 10, 10, -13, -17, -12, 52, 52, 136, 137,
	138, 139, 148, 140, 141, 142, 143, 144, 145, 146,
	147, 123, -12, 104, 105, -16, -17, -28, 79, 82,
	-9, -10, 98, -16, -12, -12, -12, -12, -145, -12,
	-61, -12, -12, -12, -12, -12, -12, -12, -159, 123,
	-40, -160, 125, 125, -164, 17, -187, -207, 12, 76,
	77, -12, 57, -146, -9, -181, -28, 79, 82, -19,
	-8, -35, -10, 123, 123, -12, -12, 123, -12, -12,
	125, -187, 17, 17, 75, -187, 125, 123, -169, -206,
	-12, 128, 125, 125, 82, -171, -28, 78, 125, 119,
	-8, 134, 78, -180, 119, 124, 121, 119, -27, -28,
	121, 135, -30, -3, -28, 82, -31, -4, -28, 82,
	29, -28, 10, 136, -22, 120, -23, -37, -38, 51,
	-41, 122, -40, -23, -54, -136, -12, -59, 121, -86,
	121, 121, 121, 121, 135, -14, 119, -17, 121, 135,
	-86, 136, 121, 135, -150, -151, -152, -153, -12, -12,
	-12, -12, -12, -12, -12, -12, -12, -12, -12, -12,
	-12, -12, -12, -12, -12, -12, -12, -12, -12, -146,
	-155, 122, -63, -83, -17, -17, -13, 123, -32, 121,
	121, 10, -165, -92, 55, -97, 58, -12, 128, -12,
	-12, -12, -12, -12, -12, -12, -12, -12, -12, -12,
	-12, -101, -204, -17, 59, 82, -28, 78, 78, 124,
	124, 124, 124, -12, -11, -12, -11, 118, -207, -207,
	17, 125, 57, -12, 11, -17, -183, -203, -176, -174,
	-8, -35, 10, 119, -147, 78, 82, -28, 57, -8,
	78, -210, -211, -17, -13, -17, -13, -12, -11, 117,
	75, 75, -11, -169, 126, -195, 135, 58, -15, -17,
	-11, -11, 10, -111, 123, -173, -174, -176, 10, 52,
	-11, -12, -174, -176, 10, -111, -12, 121, -27, 120,
	-172, -2, 121, 135, 29, -28, 121, 135, 29, -28,
	10, 29, 136, -26, -188, -5, -189, -28, 79, 82,
	60, 125, -6, 62, -191, 18, 74, -9, 131, 132,
	130, 129, 123, 123, -23, -45, -50, 21, 121, 135,
	-60, 119, 122, -25, -12, 12, -167, -26, -12, -12,
	-12, -12, -12, -12, -157, 124, 135, 29, 29, -68,
	10, 120, -89, 123, -93, -73, -28, 79, 82, -98,
	55, -13, -17, -17, 91, 124, 135, 123, -28, -154,
	126, 126, -208, 10, 120, 125, 120, -196, -200, -199,
	-201, 125, 119, -8, -12, -148, -111, -176, -28, -182,
	-176, 124, 135, 124, 124, 124, 126, 126, 124, -12,
	128, -12, 128, 126, 126, 124, -112, -61, -113, -13,
	-17, 128, 83, -111, -175, -177, 126, 120, -178, -179,
	120, 120, -111, -3, 10, 29, -4, 10, 29, 10,
	-26, 125, 130, 129, 164, 167, 165, 166, 151, 128,
	152, 161, 162, 163, 88, 89, 87, 150, 149, 155,
	156, 153, 154, 157, 159, 158, 160, 127, 82, -28,
	123, -190, -194, -188, 17, 78, -188, -188, -188, -188,
	-188, 124, -42, -32, -51, -23, 122, -53, -55, -137,
	-102, 121, -102, 121, 120, 136, 123, 122, -12, 121,
	-83, -64, -17, 128, 59, -64, 124, 135, 136, -70,
	41, 123, -90, -108, -109, -110, 60, 61, -73, -94,
	56, 82, -28, 119, -99, -73, -146, 136, -204, -205,
	-143, -144, -209, 10, 13, 12, -12, -197, 125, 125,
	-111, -11, -12, 120, -183, -212, 58, -15, -15, 124,
	135, 124, -15, -12, -111, -111, -111, -111, 10, 10,
	-188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
	-188, -188, -188, -188, -188, -188, -188, -188, -188, -188,
	-188, -188, -188, -188, -188, -188, 122, -188, -28, -190,
	126, -195, 135, 58, 10, 52, 124, 121, -43, -46,
	-32, -40, -54, -12, 120, 32, 33, -102, 31, -102,
	-26, -90, -156, -65, 58, -17, 123, -65, -69, -23,
	122, 10, -26, -71, 42, 123, -90, 124, 135, -86,
	119, -99, -28, -95, 135, -149, -12, -101, -141, -140,
	-138, 125, -139, 57, 126, 126, -139, -11, -11, 126,
	120, -184, -211, -12, 128, -113, 126, -188, 122, 124,
	-188, -188, -44, 93, 94, -47, 22, 121, 121, -12,
	-103, 122, 121, 120, 121, 31, 124, -12, 124, -64,
	-100, 124, -32, 136, -78, -72, 124, -166, 44, -109,
	-87, 83, -95, 120, -114, -115, -118, -119, -120, -135,
	47, 38, 44, -134, 103, 102, 101, 98, 99, 100,
	-73, -148, 124, 125, -142, -139, -11, -183, 120, 126,
	126, -185, -15, -188, 58, -40, -23, -48, 93, 94,
	121, -56, -103, -105, 121, -166, -66, -23, 122, -101,
	-66, 28, -26, 119, -73, 119, 119, 123, 12, 120,
	-116, 121, 135, -88, -134, 10, -123, -73, -11, -138,
	126, -198, -186, 57, -188, -106, 95, -40, 122, -54,
	-104, -32, 119, -32, 124, 121, -32, -74, -32, -32,
	-170, 12, 128, 136, -117, 12, 10, -86, 136, -124,
	135, 121, 119, 126, -196, -183, -23, 121, 122, -32,
	124, -32, -32, 26, 120, 12, 120, 120, 124, 135,
	12, -26, 121, 135, 136, 136, 10, -26, -73, -125,
	-126, -127, -128, -129, -130, -132, -73, 10, -107, -57,
	120, 121, 124, 12, 128, 12, -26, -26, -121, 120,
	-127, 121, 121, 45, 29, 78, -32, -58, -23, 122,
	-75, 12, 136, 123, -131, -73, -133, -134, 10, -32,
	119, -26, -90, 135, 10, 24, -32, 124, -73, 121,
	120, -122, 121, 119, -76, -32, -77, -79, -80, 41,
	120, -80, 123, -73, -81, 12, 124, -82, 119, -32,
	120,
}
var yyDef = [...]int{

	3, -2, 1, 2, 6, 7, 8, 0, 0, 0,
	0, 43, 4, 105, 106, 0, 38, 0, 52, 55,
	0, 0, 0, 0, 0, 0, 0, 383, 0, 75,
	0, 0, 0, 80, 82, 0, 0, 0, 107, 0,
	0, 345, 483, 484, 360, 117, 0, 119, 0, 123,
	-2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	320, 321, 0, 329, 0, 0, 0, 0, 0, 0,
	0, 399, 338, 340, 341, 342, 402, 0, 491, 0,
	0, 0, 0, 0, 0, 0, 0, 468, 469, 470,
	471, 0, 0, 474, 409, 0, 538, 510, 511, 512,
	464, -2, 0, 0, 407, 408, 410, 411, 412, 413,
	414, 415, 416, -2, 0, 515, 0, 381, 518, 530,
	519, 0, 0, 3, 0, 4, 0, 0, 0, 18,
	19, 0, 16, 0, 44, 0, 0, 46, 0, 0,
	0, 246, 62, 64, 0, 345, 107, 383, 0, 66,
	0, 68, 484, -2, 0, 71, 0, 187, 188, 0,
	0, 107, 193, 0, 245, 76, 286, 288, 290, 292,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 324, 0, 0, 0, 38, 0, 0, 346,
	108, 121, 115, -2, -2, 0, 118, 120, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 537, 269, 282, 284, 283, 489, -2, 0, 0,
	0, 0, 383, 285, 307, 308, 309, 310, 321, 0,
	0, 330, 331, 332, 333, 334, 335, 336, 337, 0,
	401, 0, 521, 521, 0, 403, 404, 550, 552, 0,
	0, 344, 0, 262, 390, 391, 384, 0, 0, 395,
	-2, 0, 0, 0, 0, 565, 566, 0, 568, 569,
	521, 0, 0, 0, 418, 0, 521, 538, 0, 477,
	543, 0, 521, 521, 0, 0, -2, 0, 521, 0,
	-2, 531, 0, 0, 0, 0, 10, 3, 0, -2,
	13, 0, 0, 24, 25, 0, 0, 30, 31, 0,
	0, 21, 0, 0, 37, 45, 39, 40, 41, 0,
	0, 49, 53, 0, 0, 247, 250, 0, 65, 346,
	67, 69, 70, 72, 0, 189, 0, 487, 73, 0,
	348, 0, 74, 0, 0, 0, 0, 0, 294, 295,
	296, 297, 298, 299, 300, 301, 302, 303, 304, 305,
	306, -2, -2, -2, -2, -2, -2, -2, -2, 319,
	0, 327, 0, 102, 104, -2, 484, 0, 0, 84,
	85, 111, 0, 113, 0, 124, 0, 265, 0, 270,
	271, 272, 273, 274, 275, 276, 277, 278, 279, 280,
	281, 0, 533, 534, 0, 0, -2, 0, 0, 322,
	485, 486, 400, 339, 0, 522, 0, 343, 551, 548,
	549, 553, 0, 0, 468, 0, -2, 523, 524, 527,
	503, 0, 528, 0, 405, 0, 0, 386, 392, 514,
	0, 0, 570, -2, -2, -2, 484, 0, 0, 472,
	417, 473, 0, 0, 359, 539, 478, 0, 547, 488,
	0, 0, 5, 368, 0, 0, 373, -2, -2, 578,
	0, 0, 377, -2, -2, 382, 0, 9, 0, 12,
	0, 17, 14, 0, 0, 27, 15, 0, 0, 33,
	20, 0, 0, 36, 420, 421, 422, -2, 0, 0,
	0, 475, 428, 429, 430, 409, 0, 0, 0, 0,
	0, 0, 0, 0, 47, 38, 0, 56, 58, 248,
	63, 148, 148, 186, 0, 191, 0, 194, 244, 287,
	289, 291, 293, 0, 0, 0, 0, 0, 0, 0,
	0, 86, 0, -2, 126, 122, 387, 0, 0, 0,
	0, -2, -2, 266, 0, 0, 537, 535, -2, -2,
	355, 354, 0, 555, 556, 0, 558, 493, 500, 501,
	0, 521, 0, 504, 0, 263, 406, 505, 385, 0,
	506, 562, 571, 563, 564, 567, 357, 356, 358, 541,
	0, 542, 0, 508, 509, 177, 0, 0, 180, -2,
	-2, 0, 0, 372, 0, 0, 516, 517, 0, 0,
	520, 11, 370, 23, 26, 0, 29, 32, 0, 22,
	35, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, -2,
	475, 0, 477, 482, 0, 0, 438, 439, 461, 462,
	0, 0, 157, 50, 54, 155, 38, 0, 246, 0,
	0, 148, 0, 148, 190, 0, -2, 325, 328, 77,
	103, 130, 132, 0, 0, 130, 0, 0, 0, 92,
	0, -2, 0, 167, 169, 107, 174, 175, 176, 0,
	0, 0, 389, 196, 125, 128, 267, 0, 532, 537,
	323, 0, 0, 559, 560, 561, 0, 490, 521, 521,
	499, 0, 0, 529, 393, 0, 0, 545, 546, 178,
	0, 179, 184, 185, 374, 376, 378, 380, 28, 34,
	0, 432, 433, 434, 435, 436, 437, 440, 441, 442,
	443, 444, 445, 446, 447, 448, 449, 450, -2, -2,
	-2, -2, -2, -2, -2, -2, 0, 0, -2, 0,
	427, 476, 478, 0, 419, 577, 463, 42, 163, 160,
	0, 0, 0, 249, 144, 0, 0, 0, 0, 0,
	192, 0, 0, 0, 0, 133, 134, 0, 81, 140,
	38, 0, 142, 83, 93, 87, 0, 361, 173, 109,
	196, 127, 388, 228, 0, 405, 264, 0, 261, -2,
	258, 521, 252, 0, 554, 0, 492, 0, 0, 525,
	526, 397, 572, 540, 0, 181, 431, 459, 0, 426,
	480, 481, 48, 0, 0, 165, 0, 57, 59, 0,
	151, 153, 154, 145, 146, 0, 361, 326, 0, 131,
	537, 0, 0, 0, 0, 0, 0, 0, 0, 170,
	0, 110, 228, 116, 195, 197, 0, 200, 0, -2,
	227, 0, 0, 230, 232, 233, 234, 235, 236, 237,
	129, 268, 536, 521, 0, 251, 0, 494, 557, 497,
	496, 394, 544, 460, 0, 158, 164, 0, 0, 0,
	156, 246, 149, 38, 147, 0, 78, 138, 38, 0,
	79, 0, 143, 38, 88, 38, 38, 0, 171, 114,
	0, 199, 0, 107, 231, 0, 0, 204, 0, 256,
	254, -2, 396, 0, 479, 0, 0, 0, 38, 0,
	38, 152, 38, 0, 135, 141, 0, 0, 0, 0,
	0, 365, 0, 0, 0, 240, 0, 0, 0, 203,
	0, 206, 208, 253, 495, 398, 159, 51, 161, 166,
	60, 150, 0, 0, 94, 0, 112, 347, 362, 0,
	366, 172, 198, 0, 0, 0, 201, 243, 205, 0,
	209, 210, 0, 0, 218, 0, 0, -2, 38, 0,
	349, 139, 89, 363, 0, 238, 241, 242, 0, 207,
	211, 212, 213, 0, 222, 0, 162, 61, 136, 38,
	0, 364, 0, -2, 214, 215, 0, -2, 219, 0,
	38, 239, 0, 0, 220, 0, 0, 0, 216, 137,
	90, 202, 224, 38, 96, 0, 91, 95, 97, 0,
	225, 98, 0, 99, 0, 0, 100, 0, 38, 0,
	101,
}
var yyTok1 = [...]int{

	1, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 131, 117, 3, 134, 166, 128, 3,
	123, 124, 164, 130, 135, 129, 163, 165, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 122, 121,
	157, 136, 159, 127, 133, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 125, 3, 126, 152, 3, 118, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 119, 151, 120, 132,
}
var yyTok2 = [...]int{

	2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	12, 13, 14, 15, 16, 17, 18, 19, 20, 21,
	22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	32, 33, 34, 35, 36, 37, 38, 39, 40, 41,
	42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
	52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
	62, 63, 64, 65, 66, 67, 68, 69, 70, 71,
	72, 73, 74, 75, 76, 77, 78, 79, 80, 81,
	82, 83, 84, 85, 86, 87, 88, 89, 90, 91,
	92, 93, 94, 95, 96, 97, 98, 99, 100, 101,
	102, 103, 104, 105, 106, 107, 108, 109, 110, 111,
	112, 113, 114, 115, 116, 137, 138, 139, 140, 141,
	142, 143, 144, 145, 146, 147, 148, 149, 150, 153,
	154, 155, 156, 158, 160, 161, 162, 167,
}
var yyTok3 = [...]int{
	0,
}

var yyErrorMessages = [...]struct {
	state int
	token int
	msg   string
}{}

//line yaccpar:1

/*	parser for yacc output	*/

var (
	yyDebug        = 0
	yyErrorVerbose = false
)

type yyLexer interface {
	Lex(lval *yySymType) int
	Error(s string)
}

type yyParser interface {
	Parse(yyLexer) int
	Lookahead() int
}

type yyParserImpl struct {
	lval  yySymType
	stack [yyInitialStackSize]yySymType
	char  int
}

func (p *yyParserImpl) Lookahead() int {
	return p.char
}

func yyNewParser() yyParser {
	return &yyParserImpl{}
}

const yyFlag = -1000

func yyTokname(c int) string {
	if c >= 1 && c-1 < len(yyToknames) {
		if yyToknames[c-1] != "" {
			return yyToknames[c-1]
		}
	}
	return __yyfmt__.Sprintf("tok-%v", c)
}

func yyStatname(s int) string {
	if s >= 0 && s < len(yyStatenames) {
		if yyStatenames[s] != "" {
			return yyStatenames[s]
		}
	}
	return __yyfmt__.Sprintf("state-%v", s)
}

func yyErrorMessage(state, lookAhead int) string {
	const TOKSTART = 4

	if !yyErrorVerbose {
		return "syntax error"
	}

	for _, e := range yyErrorMessages {
		if e.state == state && e.token == lookAhead {
			return "syntax error: " + e.msg
		}
	}

	res := "syntax error: unexpected " + yyTokname(lookAhead)

	// To match Bison, suggest at most four expected tokens.
	expected := make([]int, 0, 4)

	// Look for shiftable tokens.
	base := yyPact[state]
	for tok := TOKSTART; tok-1 < len(yyToknames); tok++ {
		if n := base + tok; n >= 0 && n < yyLast && yyChk[yyAct[n]] == tok {
			if len(expected) == cap(expected) {
				return res
			}
			expected = append(expected, tok)
		}
	}

	if yyDef[state] == -2 {
		i := 0
		for yyExca[i] != -1 || yyExca[i+1] != state {
			i += 2
		}

		// Look for tokens that we accept or reduce.
		for i += 2; yyExca[i] >= 0; i += 2 {
			tok := yyExca[i]
			if tok < TOKSTART || yyExca[i+1] == 0 {
				continue
			}
			if len(expected) == cap(expected) {
				return res
			}
			expected = append(expected, tok)
		}

		// If the default action is to accept or reduce, give up.
		if yyExca[i+1] != 0 {
			return res
		}
	}

	for i, tok := range expected {
		if i == 0 {
			res += ", expecting "
		} else {
			res += " or "
		}
		res += yyTokname(tok)
	}
	return res
}

func yylex1(lex yyLexer, lval *yySymType) (char, token int) {
	token = 0
	char = lex.Lex(lval)
	if char <= 0 {
		token = yyTok1[0]
		goto out
	}
	if char < len(yyTok1) {
		token = yyTok1[char]
		goto out
	}
	if char >= yyPrivate {
		if char < yyPrivate+len(yyTok2) {
			token = yyTok2[char-yyPrivate]
			goto out
		}
	}
	for i := 0; i < len(yyTok3); i += 2 {
		token = yyTok3[i+0]
		if token == char {
			token = yyTok3[i+1]
			goto out
		}
	}

out:
	if token == 0 {
		token = yyTok2[1] /* unknown char */
	}
	if yyDebug >= 3 {
		__yyfmt__.Printf("lex %s(%d)\n", yyTokname(token), uint(char))
	}
	return char, token
}

func yyParse(yylex yyLexer) int {
	return yyNewParser().Parse(yylex)
}

func (yyrcvr *yyParserImpl) Parse(yylex yyLexer) int {
	var yyn int
	var yyVAL yySymType
	var yyDollar []yySymType
	_ = yyDollar // silence set and not used
	yyS := yyrcvr.stack[:]

	Nerrs := 0   /* number of errors */
	Errflag := 0 /* error recovery flag */
	yystate := 0
	yyrcvr.char = -1
	yytoken := -1 // yyrcvr.char translated into internal numbering
	defer func() {
		// Make sure we report no lookahead when not parsing.
		yystate = -1
		yyrcvr.char = -1
		yytoken = -1
	}()
	yyp := -1
	goto yystack

ret0:
	return 0

ret1:
	return 1

yystack:
	/* put a state and value onto the stack */
	if yyDebug >= 4 {
		__yyfmt__.Printf("char %v in %v\n", yyTokname(yytoken), yyStatname(yystate))
	}

	yyp++
	if yyp >= len(yyS) {
		nyys := make([]yySymType, len(yyS)*2)
		copy(nyys, yyS)
		yyS = nyys
	}
	yyS[yyp] = yyVAL
	yyS[yyp].yys = yystate

yynewstate:
	yyn = yyPact[yystate]
	if yyn <= yyFlag {
		goto yydefault /* simple state */
	}
	if yyrcvr.char < 0 {
		yyrcvr.char, yytoken = yylex1(yylex, &yyrcvr.lval)
	}
	yyn += yytoken
	if yyn < 0 || yyn >= yyLast {
		goto yydefault
	}
	yyn = yyAct[yyn]
	if yyChk[yyn] == yytoken { /* valid shift */
		yyrcvr.char = -1
		yytoken = -1
		yyVAL = yyrcvr.lval
		yystate = yyn
		if Errflag > 0 {
			Errflag--
		}
		goto yystack
	}

yydefault:
	/* default state action */
	yyn = yyDef[yystate]
	if yyn == -2 {
		if yyrcvr.char < 0 {
			yyrcvr.char, yytoken = yylex1(yylex, &yyrcvr.lval)
		}

		/* look through exception table */
		xi := 0
		for {
			if yyExca[xi+0] == -1 && yyExca[xi+1] == yystate {
				break
			}
			xi += 2
		}
		for xi += 2; ; xi += 2 {
			yyn = yyExca[xi+0]
			if yyn < 0 || yyn == yytoken {
				break
			}
		}
		yyn = yyExca[xi+1]
		if yyn < 0 {
			goto ret0
		}
	}
	if yyn == 0 {
		/* error ... attempt to resume parsing */
		switch Errflag {
		case 0: /* brand new error */
			yylex.Error(yyErrorMessage(yystate, yytoken))
			Nerrs++
			if yyDebug >= 1 {
				__yyfmt__.Printf("%s", yyStatname(yystate))
				__yyfmt__.Printf(" saw %s\n", yyTokname(yytoken))
			}
			fallthrough

		case 1, 2: /* incompletely recovered error ... try again */
			Errflag = 3

			/* find a state where "error" is a legal shift action */
			for yyp >= 0 {
				yyn = yyPact[yyS[yyp].yys] + yyErrCode
				if yyn >= 0 && yyn < yyLast {
					yystate = yyAct[yyn] /* simulate a shift of "error" */
					if yyChk[yystate] == yyErrCode {
						goto yystack
					}
				}

				/* the current p has no shift on "error", pop stack */
				if yyDebug >= 2 {
					__yyfmt__.Printf("error recovery pops state %d\n", yyS[yyp].yys)
				}
				yyp--
			}
			/* there is no state on the stack with an error shift ... abort */
			goto ret1

		case 3: /* no shift yet; clobber input char */
			if yyDebug >= 2 {
				__yyfmt__.Printf("error recovery discards %s\n", yyTokname(yytoken))
			}
			if yytoken == yyEofCode {
				goto ret1
			}
			yyrcvr.char = -1
			yytoken = -1
			goto yynewstate /* try again in the same state */
		}
	}

	/* reduction by production yyn */
	if yyDebug >= 2 {
		__yyfmt__.Printf("reduce %v in:\n\t%v\n", yyn, yyStatname(yystate))
	}

	yynt := yyn
	yypt := yyp
	_ = yypt // guard against "declared and not used"

	yyp -= yyR2[yyn]
	// yyp is now the index of $0. Perform the default action. Iff the
	// reduced production is ε, $1 is possibly out of range.
	if yyp+1 >= len(yyS) {
		nyys := make([]yySymType, len(yyS)*2)
		copy(nyys, yyS)
		yyS = nyys
	}
	yyVAL = yyS[yyp+1]

	/* consult goto table to find next state */
	yyn = yyR1[yyn]
	yyg := yyPgo[yyn]
	yyj := yyg + yyS[yyp].yys + 1

	if yyj >= yyLast {
		yystate = yyAct[yyg]
	} else {
		yystate = yyAct[yyj]
		if yyChk[yystate] != -yyn {
			yystate = yyAct[yyg]
		}
	}
	// dummy call; replaced with literal code
	switch yynt {

	case 1:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:211
		{
			rootnode = stmt.NewStmtList(yyDollar[1].list)
		}
	case 2:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:217
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 3:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:218
		{
			yyVAL.list = []node.Node{}
		}
	case 4:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:223
		{
			namePart := name.NewNamePart(yyDollar[1].token.Value)
			positions.AddPosition(namePart, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.list = []node.Node{namePart}
			comments.AddComments(namePart, yyDollar[1].token.Comments())
		}
	case 5:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:230
		{
			namePart := name.NewNamePart(yyDollar[3].token.Value)
			positions.AddPosition(namePart, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.list = append(yyDollar[1].list, namePart)
			comments.AddComments(namePart, yyDollar[3].token.Comments())
		}
	case 6:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:239
		{
			yyVAL.node = yyDollar[1].node
		}
	case 7:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:240
		{
			yyVAL.node = nil
		}
	case 8:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:241
		{
			yyVAL.node = nil
		}
	case 9:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:242
		{
			yyVAL.node = stmt.NewHaltCompiler()
		}
	case 10:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:244
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewNamespace(name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 11:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:254
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewNamespace(name, yyDollar[4].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[5].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 12:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:264
		{
			yyVAL.node = stmt.NewNamespace(nil, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 13:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:270
		{
			yyVAL.node = stmt.NewUseList(nil, yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 14:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:276
		{
			useType := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[2].token.Comments())

			yyVAL.node = stmt.NewUseList(useType, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 15:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:286
		{
			useType := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[2].token.Comments())

			yyVAL.node = stmt.NewUseList(useType, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 16:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:295
		{
			yyVAL.node = nil
		}
	case 17:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:299
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 18:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:300
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 19:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:305
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 20:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:315
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 21:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:328
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 22:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:338
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 23:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:354
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 24:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:358
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 25:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:365
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 26:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:375
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 27:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:388
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 28:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:398
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 29:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:414
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 30:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:418
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 31:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:425
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 32:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:435
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 33:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:448
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 34:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:458
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 35:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:473
		{
		}
	case 36:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:474
		{
		}
	case 37:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:478
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 38:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:479
		{
			yyVAL.list = []node.Node{}
		}
	case 39:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:484
		{
			yyVAL.node = yyDollar[1].node
		}
	case 40:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:485
		{
			yyVAL.node = nil
		}
	case 41:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:486
		{
		}
	case 42:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:487
		{
		}
	case 43:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:492
		{
			yyVAL.node = yyDollar[1].node
		}
	case 44:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:493
		{
		}
	case 45:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:497
		{
		}
	case 46:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:498
		{
		}
	case 47:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:498
		{
		}
	case 48:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:498
		{
		}
	case 49:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:499
		{
		}
	case 50:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:499
		{
		}
	case 51:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:499
		{
		}
	case 52:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:500
		{
		}
	case 53:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:500
		{
		}
	case 54:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:500
		{
		}
	case 55:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:501
		{
		}
	case 56:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:501
		{
		}
	case 57:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:501
		{
		}
	case 58:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:505
		{
		}
	case 59:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:507
		{
		}
	case 60:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:509
		{
		}
	case 61:
		yyDollar = yyS[yypt-12 : yypt+1]
		//line php5/php5.y:510
		{
		}
	case 62:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:511
		{
		}
	case 63:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:511
		{
		}
	case 64:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:512
		{
		}
	case 65:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:513
		{
		}
	case 66:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:514
		{
		}
	case 67:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:515
		{
		}
	case 68:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:516
		{
		}
	case 69:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:517
		{
		}
	case 70:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:518
		{
		}
	case 71:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:519
		{
		}
	case 72:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:520
		{
		}
	case 73:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:521
		{
		}
	case 74:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:522
		{
		}
	case 75:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:523
		{
		}
	case 76:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:524
		{
			yyVAL.node = yyDollar[1].node
		}
	case 77:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:525
		{
		}
	case 78:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:526
		{
		}
	case 79:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:527
		{
		}
	case 80:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:528
		{
		}
	case 81:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:528
		{
		}
	case 82:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:529
		{
		}
	case 83:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:530
		{
		}
	case 84:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:531
		{
		}
	case 85:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:532
		{
		}
	case 86:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:536
		{
		}
	case 87:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:537
		{
		}
	case 88:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:538
		{
		}
	case 89:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:539
		{
		}
	case 90:
		yyDollar = yyS[yypt-11 : yypt+1]
		//line php5/php5.y:540
		{
		}
	case 91:
		yyDollar = yyS[yypt-13 : yypt+1]
		//line php5/php5.y:541
		{
		}
	case 92:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:544
		{
		}
	case 93:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:545
		{
		}
	case 94:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:545
		{
		}
	case 95:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:549
		{
		}
	case 96:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:550
		{
		}
	case 97:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:554
		{
		}
	case 98:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:555
		{
		}
	case 99:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:559
		{
		}
	case 100:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:559
		{
		}
	case 101:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:559
		{
		}
	case 104:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:568
		{
		}
	case 105:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:572
		{
		}
	case 106:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:576
		{
		}
	case 107:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:580
		{
		}
	case 108:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:581
		{
		}
	case 109:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:585
		{
		}
	case 110:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:586
		{
		}
	case 111:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:590
		{
		}
	case 112:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:592
		{
		}
	case 113:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:597
		{
		}
	case 114:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:601
		{
		}
	case 115:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:603
		{
		}
	case 116:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:607
		{
		}
	case 117:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:612
		{
		}
	case 118:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:613
		{
		}
	case 119:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:614
		{
		}
	case 120:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:615
		{
		}
	case 121:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:619
		{
		}
	case 122:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:620
		{
		}
	case 123:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:624
		{
		}
	case 128:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:638
		{
		}
	case 129:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:639
		{
		}
	case 130:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:643
		{
		}
	case 131:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:644
		{
		}
	case 132:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:648
		{
		}
	case 133:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:649
		{
		}
	case 134:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:650
		{
		}
	case 135:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:650
		{
		}
	case 142:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:672
		{
		}
	case 143:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:673
		{
		}
	case 144:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:678
		{
		}
	case 145:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:679
		{
		}
	case 146:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:680
		{
		}
	case 147:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:681
		{
		}
	case 148:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:686
		{
		}
	case 149:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:687
		{
		}
	case 150:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:687
		{
		}
	case 151:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:688
		{
		}
	case 152:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:688
		{
		}
	case 158:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:707
		{
		}
	case 159:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:707
		{
		}
	case 161:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:713
		{
		}
	case 162:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:713
		{
		}
	case 171:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:742
		{
		}
	case 172:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:744
		{
		}
	case 173:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:749
		{
		}
	case 174:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:750
		{
		}
	case 175:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:751
		{
		}
	case 176:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:752
		{
		}
	case 177:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:757
		{
		}
	case 178:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:758
		{
		}
	case 179:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:759
		{
		}
	case 182:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:769
		{
		}
	case 183:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:770
		{
		}
	case 184:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:771
		{
		}
	case 185:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:772
		{
		}
	case 186:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:776
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 187:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:777
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 188:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:783
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 189:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:793
		{
			yyVAL.node = expr.NewVariable(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 190:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:799
		{
			yyVAL.node = expr.NewVariable(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 191:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:809
		{
			identifier := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[3].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[3].token))

			staticVar := stmt.NewStaticVar(variable, nil)
			positions.AddPosition(staticVar, positionBuilder.NewTokenPosition(yyDollar[3].token))

			yyVAL.list = append(yyDollar[1].list, staticVar)

			comments.AddComments(identifier, yyDollar[3].token.Comments())
			comments.AddComments(variable, yyDollar[3].token.Comments())
			comments.AddComments(staticVar, yyDollar[3].token.Comments())
		}
	case 192:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:826
		{
			identifier := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[3].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[3].token))

			staticVar := stmt.NewStaticVar(variable, yyDollar[5].node)
			positions.AddPosition(staticVar, positionBuilder.NewTokenNodePosition(yyDollar[3].token, yyDollar[5].node))

			yyVAL.list = append(yyDollar[1].list, staticVar)

			comments.AddComments(identifier, yyDollar[3].token.Comments())
			comments.AddComments(variable, yyDollar[3].token.Comments())
			comments.AddComments(staticVar, yyDollar[3].token.Comments())
		}
	case 193:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:843
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))

			staticVar := stmt.NewStaticVar(variable, nil)
			positions.AddPosition(staticVar, positionBuilder.NewTokenPosition(yyDollar[1].token))

			yyVAL.list = []node.Node{staticVar}

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(staticVar, yyDollar[1].token.Comments())
		}
	case 194:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:860
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))

			staticVar := stmt.NewStaticVar(variable, yyDollar[3].node)
			positions.AddPosition(staticVar, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[3].node))

			yyVAL.list = []node.Node{staticVar}

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(staticVar, yyDollar[1].token.Comments())
		}
	case 197:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:887
		{
		}
	case 201:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:890
		{
		}
	case 202:
		yyDollar = yyS[yypt-9 : yypt+1]
		//line php5/php5.y:892
		{
		}
	case 204:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:900
		{
		}
	case 205:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:901
		{
		}
	case 214:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:925
		{
		}
	case 215:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:929
		{
		}
	case 216:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:930
		{
		}
	case 217:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:934
		{
		}
	case 218:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:935
		{
		}
	case 219:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:939
		{
		}
	case 220:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:943
		{
		}
	case 221:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:944
		{
		}
	case 222:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:948
		{
		}
	case 223:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:949
		{
		}
	case 224:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:953
		{
		}
	case 225:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:954
		{
		}
	case 226:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:958
		{
		}
	case 227:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:959
		{
		}
	case 228:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:963
		{
		}
	case 229:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:964
		{
		}
	case 230:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:968
		{
		}
	case 231:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:969
		{
		}
	case 232:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:973
		{
		}
	case 233:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:974
		{
		}
	case 234:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:975
		{
		}
	case 235:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:976
		{
		}
	case 236:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:977
		{
		}
	case 237:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:978
		{
		}
	case 238:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:982
		{
		}
	case 239:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:983
		{
		}
	case 240:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:984
		{
		}
	case 241:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:985
		{
		}
	case 242:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:989
		{
		}
	case 243:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:990
		{
		}
	case 244:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:994
		{
		}
	case 245:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:995
		{
		}
	case 246:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1000
		{
		}
	case 247:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1001
		{
		}
	case 248:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1005
		{
		}
	case 249:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1005
		{
		}
	case 250:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1006
		{
		}
	case 251:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1010
		{
		}
	case 252:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1011
		{
		}
	case 253:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1015
		{
		}
	case 254:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1016
		{
		}
	case 255:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1020
		{
		}
	case 256:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1020
		{
		}
	case 257:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1021
		{
		}
	case 258:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1022
		{
		}
	case 259:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1026
		{
		}
	case 260:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1027
		{
		}
	case 261:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1028
		{
		}
	case 262:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1032
		{
		}
	case 263:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1032
		{
		}
	case 264:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1036
		{
			yyVAL.node = nil
		}
	case 265:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1037
		{
		}
	case 266:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1038
		{
		}
	case 267:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1039
		{
		}
	case 268:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:1039
		{
		}
	case 269:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1040
		{
		}
	case 270:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1041
		{
		}
	case 271:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1042
		{
		}
	case 272:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1043
		{
		}
	case 273:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1044
		{
		}
	case 274:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1045
		{
		}
	case 275:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1046
		{
		}
	case 276:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1047
		{
		}
	case 277:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1048
		{
		}
	case 278:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1049
		{
		}
	case 279:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1050
		{
		}
	case 280:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1051
		{
		}
	case 281:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1052
		{
		}
	case 282:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1053
		{
		}
	case 283:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1054
		{
		}
	case 284:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1055
		{
		}
	case 285:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1056
		{
		}
	case 286:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1057
		{
		}
	case 287:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1057
		{
		}
	case 288:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1058
		{
		}
	case 289:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1058
		{
		}
	case 290:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1059
		{
		}
	case 291:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1059
		{
		}
	case 292:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1060
		{
		}
	case 293:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1060
		{
		}
	case 294:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1061
		{
		}
	case 295:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1062
		{
		}
	case 296:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1063
		{
		}
	case 297:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1064
		{
		}
	case 298:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1065
		{
		}
	case 299:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1066
		{
		}
	case 300:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1067
		{
		}
	case 301:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1068
		{
		}
	case 302:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1069
		{
		}
	case 303:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1070
		{
		}
	case 304:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1071
		{
		}
	case 305:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1072
		{
		}
	case 306:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1073
		{
		}
	case 307:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1074
		{
		}
	case 308:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1075
		{
		}
	case 309:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1076
		{
		}
	case 310:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1077
		{
		}
	case 311:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1078
		{
		}
	case 312:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1079
		{
		}
	case 313:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1080
		{
		}
	case 314:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1081
		{
		}
	case 315:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1082
		{
		}
	case 316:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1083
		{
		}
	case 317:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1084
		{
		}
	case 318:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1085
		{
		}
	case 319:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1086
		{
		}
	case 320:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1087
		{
		}
	case 321:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1088
		{
		}
	case 322:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1089
		{
		}
	case 323:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1089
		{
		}
	case 324:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1090
		{
		}
	case 325:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1091
		{
		}
	case 326:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:1092
		{
		}
	case 327:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1093
		{
		}
	case 328:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1094
		{
		}
	case 329:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1095
		{
		}
	case 330:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1096
		{
		}
	case 331:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1097
		{
		}
	case 332:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1098
		{
		}
	case 333:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1099
		{
		}
	case 334:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1100
		{
		}
	case 335:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1101
		{
		}
	case 336:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1102
		{
		}
	case 337:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1103
		{
		}
	case 338:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1104
		{
		}
	case 339:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1104
		{
		}
	case 340:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1105
		{
		}
	case 341:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1106
		{
		}
	case 342:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1107
		{
		}
	case 343:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1108
		{
		}
	case 344:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1109
		{
		}
	case 345:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1110
		{
		}
	case 346:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1111
		{
		}
	case 347:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:1113
		{
		}
	case 348:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1114
		{
		}
	case 349:
		yyDollar = yyS[yypt-11 : yypt+1]
		//line php5/php5.y:1116
		{
		}
	case 350:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1120
		{
		}
	case 351:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1121
		{
		}
	case 352:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1122
		{
		}
	case 353:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1123
		{
		}
	case 354:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1127
		{
		}
	case 355:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1128
		{
		}
	case 356:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1129
		{
		}
	case 357:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1130
		{
		}
	case 358:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1134
		{
		}
	case 359:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1135
		{
		}
	case 360:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1139
		{
		}
	case 363:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1148
		{
		}
	case 364:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1149
		{
		}
	case 365:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1150
		{
		}
	case 366:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1151
		{
		}
	case 367:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1155
		{
		}
	case 368:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1156
		{
		}
	case 369:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1157
		{
		}
	case 370:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1158
		{
		}
	case 371:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1159
		{
		}
	case 372:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1160
		{
		}
	case 373:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1161
		{
		}
	case 374:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1162
		{
		}
	case 375:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1163
		{
		}
	case 376:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1164
		{
		}
	case 377:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1165
		{
		}
	case 378:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1166
		{
		}
	case 379:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1167
		{
		}
	case 380:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1168
		{
		}
	case 381:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1169
		{
		}
	case 382:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1170
		{
		}
	case 383:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1175
		{
			yyVAL.node = node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 384:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1181
		{
			yyVAL.node = name.NewName(yyDollar[1].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 385:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1187
		{
			yyVAL.node = name.NewRelative(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[3].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 386:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1193
		{
			yyVAL.node = name.NewFullyQualified(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 387:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1201
		{
		}
	case 388:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1202
		{
		}
	case 389:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1203
		{
		}
	case 390:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1209
		{
		}
	case 391:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1210
		{
		}
	case 392:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1215
		{
		}
	case 393:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1216
		{
		}
	case 394:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1217
		{
		}
	case 395:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1218
		{
		}
	case 398:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1229
		{
		}
	case 399:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1233
		{
		}
	case 400:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1234
		{
		}
	case 401:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1235
		{
		}
	case 402:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1239
		{
		}
	case 403:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1240
		{
		}
	case 404:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1241
		{
		}
	case 405:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1245
		{
		}
	case 406:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1246
		{
		}
	case 407:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1251
		{
			yyVAL.node = scalar.NewLnumber(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 408:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1257
		{
			yyVAL.node = scalar.NewDnumber(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 409:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1262
		{
			yyVAL.node = nil
		}
	case 410:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1264
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 411:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1270
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 412:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1276
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 413:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1282
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 414:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1288
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 415:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1294
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 416:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1300
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 417:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1305
		{
			yyVAL.node = nil
		}
	case 418:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1306
		{
			yyVAL.node = nil
		}
	case 419:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1311
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 420:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1323
		{
		}
	case 421:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1327
		{
		}
	case 422:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1328
		{
		}
	case 423:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1329
		{
		}
	case 424:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1330
		{
		}
	case 425:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1331
		{
		}
	case 426:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1332
		{
		}
	case 427:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1333
		{
		}
	case 428:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1334
		{
		}
	case 429:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1335
		{
		}
	case 430:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1336
		{
		}
	case 431:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1340
		{
		}
	case 432:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1341
		{
		}
	case 433:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1342
		{
		}
	case 434:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1343
		{
		}
	case 435:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1344
		{
		}
	case 436:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1345
		{
		}
	case 437:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1346
		{
		}
	case 438:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1347
		{
		}
	case 439:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1348
		{
		}
	case 440:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1349
		{
		}
	case 441:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1350
		{
		}
	case 442:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1351
		{
		}
	case 443:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1352
		{
		}
	case 444:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1353
		{
		}
	case 445:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1354
		{
		}
	case 446:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1355
		{
		}
	case 447:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1356
		{
		}
	case 448:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1357
		{
		}
	case 449:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1358
		{
		}
	case 450:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1359
		{
		}
	case 451:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1360
		{
		}
	case 452:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1361
		{
		}
	case 453:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1362
		{
		}
	case 454:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1363
		{
		}
	case 455:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1364
		{
		}
	case 456:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1365
		{
		}
	case 457:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1366
		{
		}
	case 458:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1367
		{
		}
	case 459:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1368
		{
		}
	case 460:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1369
		{
		}
	case 461:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1370
		{
		}
	case 462:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1371
		{
		}
	case 463:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1372
		{
		}
	case 464:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1376
		{
		}
	case 465:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1377
		{
		}
	case 466:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1378
		{
		}
	case 467:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1379
		{
		}
	case 468:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1383
		{
		}
	case 469:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1384
		{
		}
	case 470:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1385
		{
		}
	case 471:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1386
		{
		}
	case 472:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1387
		{
		}
	case 473:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1388
		{
		}
	case 474:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1389
		{
		}
	case 475:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1393
		{
		}
	case 476:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1394
		{
		}
	case 479:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1403
		{
		}
	case 480:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1404
		{
		}
	case 481:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1405
		{
		}
	case 482:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1406
		{
		}
	case 483:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1410
		{
			yyVAL.node = yyDollar[1].node
		}
	case 484:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1411
		{
		}
	case 485:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1415
		{
		}
	case 486:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1416
		{
		}
	case 487:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1422
		{
			yyVAL.node = yyDollar[1].node
		}
	case 488:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1430
		{
			yyVAL.node = yyDollar[1].node
		}
	case 489:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1437
		{
			yyVAL.node = yyDollar[1].node
		}
	case 490:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1444
		{
		}
	case 491:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1446
		{
			yyVAL.node = yyDollar[1].node
		}
	case 492:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1450
		{
		}
	case 493:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1451
		{
		}
	case 494:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1456
		{
		}
	case 495:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1456
		{
		}
	case 496:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1460
		{
		}
	case 497:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1461
		{
		}
	case 498:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1465
		{
		}
	case 499:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1466
		{
		}
	case 500:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1470
		{
		}
	case 501:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1471
		{
		}
	case 502:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1472
		{
		}
	case 503:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1476
		{
		}
	case 504:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1477
		{
		}
	case 505:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1481
		{
		}
	case 506:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1482
		{
		}
	case 507:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1488
		{
			yyVAL.node = yyDollar[1].node
		}
	case 508:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1494
		{
		}
	case 509:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1495
		{
		}
	case 510:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1499
		{
			yyVAL.node = yyDollar[1].node
		}
	case 511:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1500
		{
			yyVAL.node = yyDollar[1].node
		}
	case 512:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1501
		{
			yyVAL.node = yyDollar[1].node
		}
	case 513:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1506
		{
			yyVAL.node = yyDollar[1].node
		}
	case 514:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1508
		{
			yyDollar[1].simpleIndirectReference.last.SetVarName(yyDollar[2].node)

			for _, n := range yyDollar[1].simpleIndirectReference.all {
				positions[n] = positionBuilder.NewNodesPosition(n, yyDollar[2].node)
			}

			yyVAL.node = yyDollar[1].simpleIndirectReference.all[0]
		}
	case 515:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1517
		{
		}
	case 516:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1522
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 517:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1528
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 518:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1533
		{
			yyVAL.node = yyDollar[1].node
		}
	case 519:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1539
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 520:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1549
		{
			yyVAL.node = expr.NewVariable(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 521:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1557
		{
			yyVAL.node = nil
		}
	case 522:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1558
		{
			yyVAL.node = yyDollar[1].node
		}
	case 523:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1563
		{
		}
	case 524:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1564
		{
		}
	case 525:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1568
		{
		}
	case 526:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1569
		{
		}
	case 527:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1570
		{
		}
	case 528:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1574
		{
		}
	case 529:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1575
		{
		}
	case 530:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1580
		{
			n := expr.NewVariable(nil)
			positions.AddPosition(n, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(n, yyDollar[1].token.Comments())

			yyVAL.simpleIndirectReference = simpleIndirectReference{[]*expr.Variable{n}, n}
		}
	case 531:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1588
		{
			n := expr.NewVariable(nil)
			positions.AddPosition(n, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(n, yyDollar[2].token.Comments())

			yyDollar[1].simpleIndirectReference.last.SetVarName(n)

			yyDollar[1].simpleIndirectReference.all = append(yyDollar[1].simpleIndirectReference.all, n)
			yyDollar[1].simpleIndirectReference.last = n
			yyVAL.simpleIndirectReference = yyDollar[1].simpleIndirectReference
		}
	case 534:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1608
		{
		}
	case 535:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1609
		{
		}
	case 536:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1609
		{
		}
	case 537:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1610
		{
		}
	case 538:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1615
		{
		}
	case 539:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1616
		{
		}
	case 540:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1620
		{
		}
	case 541:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1621
		{
		}
	case 542:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1622
		{
		}
	case 543:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1623
		{
		}
	case 544:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1624
		{
		}
	case 545:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1625
		{
		}
	case 546:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1626
		{
		}
	case 547:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1627
		{
		}
	case 548:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1631
		{
		}
	case 549:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1632
		{
		}
	case 550:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1633
		{
		}
	case 551:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1634
		{
		}
	case 552:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1640
		{
		}
	case 553:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1641
		{
		}
	case 554:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1641
		{
		}
	case 555:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1642
		{
		}
	case 556:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1643
		{
		}
	case 557:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1644
		{
		}
	case 558:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1645
		{
		}
	case 559:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1650
		{
		}
	case 560:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1651
		{
		}
	case 561:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1652
		{
		}
	case 562:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1657
		{
		}
	case 563:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1658
		{
		}
	case 564:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1659
		{
		}
	case 565:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1660
		{
		}
	case 566:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1661
		{
		}
	case 567:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1662
		{
		}
	case 568:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1663
		{
		}
	case 569:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1664
		{
		}
	case 570:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1668
		{
		}
	case 571:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1669
		{
		}
	case 572:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1669
		{
		}
	case 573:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1673
		{
		}
	case 574:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1674
		{
		}
	case 575:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1678
		{
		}
	case 576:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1679
		{
		}
	case 577:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1683
		{
		}
	case 578:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1687
		{
		}
	}
	goto yystack /* stack new state and value */
}
